// Compiled by ClojureScript 1.7.170 {:static-fns true, :optimize-constants true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args36006 = [];
var len__5740__auto___36012 = arguments.length;
var i__5741__auto___36013 = (0);
while(true){
if((i__5741__auto___36013 < len__5740__auto___36012)){
args36006.push((arguments[i__5741__auto___36013]));

var G__36014 = (i__5741__auto___36013 + (1));
i__5741__auto___36013 = G__36014;
continue;
} else {
}
break;
}

var G__36008 = args36006.length;
switch (G__36008) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36006.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async36009 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36009 = (function (f,blockable,meta36010){
this.f = f;
this.blockable = blockable;
this.meta36010 = meta36010;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36011,meta36010__$1){
var self__ = this;
var _36011__$1 = this;
return (new cljs.core.async.t_cljs$core$async36009(self__.f,self__.blockable,meta36010__$1));
});

cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36011){
var self__ = this;
var _36011__$1 = this;
return self__.meta36010;
});

cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async36009.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async36009.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$blockable,cljs.core.cst$sym$meta36010], null);
});

cljs.core.async.t_cljs$core$async36009.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36009.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36009";

cljs.core.async.t_cljs$core$async36009.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36009");
});

cljs.core.async.__GT_t_cljs$core$async36009 = (function cljs$core$async$__GT_t_cljs$core$async36009(f__$1,blockable__$1,meta36010){
return (new cljs.core.async.t_cljs$core$async36009(f__$1,blockable__$1,meta36010));
});

}

return (new cljs.core.async.t_cljs$core$async36009(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args36018 = [];
var len__5740__auto___36021 = arguments.length;
var i__5741__auto___36022 = (0);
while(true){
if((i__5741__auto___36022 < len__5740__auto___36021)){
args36018.push((arguments[i__5741__auto___36022]));

var G__36023 = (i__5741__auto___36022 + (1));
i__5741__auto___36022 = G__36023;
continue;
} else {
}
break;
}

var G__36020 = args36018.length;
switch (G__36020) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36018.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.cst$sym$buf_DASH_or_DASH_n], 0)))].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args36025 = [];
var len__5740__auto___36028 = arguments.length;
var i__5741__auto___36029 = (0);
while(true){
if((i__5741__auto___36029 < len__5740__auto___36028)){
args36025.push((arguments[i__5741__auto___36029]));

var G__36030 = (i__5741__auto___36029 + (1));
i__5741__auto___36029 = G__36030;
continue;
} else {
}
break;
}

var G__36027 = args36025.length;
switch (G__36027) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36025.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args36032 = [];
var len__5740__auto___36035 = arguments.length;
var i__5741__auto___36036 = (0);
while(true){
if((i__5741__auto___36036 < len__5740__auto___36035)){
args36032.push((arguments[i__5741__auto___36036]));

var G__36037 = (i__5741__auto___36036 + (1));
i__5741__auto___36036 = G__36037;
continue;
} else {
}
break;
}

var G__36034 = args36032.length;
switch (G__36034) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36032.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_36039 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36039) : fn1.call(null,val_36039));
} else {
cljs.core.async.impl.dispatch.run(((function (val_36039,ret){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36039) : fn1.call(null,val_36039));
});})(val_36039,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args36040 = [];
var len__5740__auto___36043 = arguments.length;
var i__5741__auto___36044 = (0);
while(true){
if((i__5741__auto___36044 < len__5740__auto___36043)){
args36040.push((arguments[i__5741__auto___36044]));

var G__36045 = (i__5741__auto___36044 + (1));
i__5741__auto___36044 = G__36045;
continue;
} else {
}
break;
}

var G__36042 = args36040.length;
switch (G__36042) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36040.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4651__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4651__auto__)){
var ret = temp__4651__auto__;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4651__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__4651__auto__)){
var retb = temp__4651__auto__;
var ret = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(retb) : cljs.core.deref.call(null,retb));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__4651__auto__){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
});})(ret,retb,temp__4651__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5585__auto___36047 = n;
var x_36048 = (0);
while(true){
if((x_36048 < n__5585__auto___36047)){
(a[x_36048] = (0));

var G__36049 = (x_36048 + (1));
x_36048 = G__36049;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__36050 = (i + (1));
i = G__36050;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true) : cljs.core.atom.call(null,true));
if(typeof cljs.core.async.t_cljs$core$async36054 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36054 = (function (alt_flag,flag,meta36055){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta36055 = meta36055;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_36056,meta36055__$1){
var self__ = this;
var _36056__$1 = this;
return (new cljs.core.async.t_cljs$core$async36054(self__.alt_flag,self__.flag,meta36055__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_36056){
var self__ = this;
var _36056__$1 = this;
return self__.meta36055;
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.flag) : cljs.core.deref.call(null,self__.flag));
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.flag,null) : cljs.core.reset_BANG_.call(null,self__.flag,null));

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_flag,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$meta36055], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async36054.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36054.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36054";

cljs.core.async.t_cljs$core$async36054.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36054");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async36054 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async36054(alt_flag__$1,flag__$1,meta36055){
return (new cljs.core.async.t_cljs$core$async36054(alt_flag__$1,flag__$1,meta36055));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async36054(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async36060 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36060 = (function (alt_handler,flag,cb,meta36061){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta36061 = meta36061;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36062,meta36061__$1){
var self__ = this;
var _36062__$1 = this;
return (new cljs.core.async.t_cljs$core$async36060(self__.alt_handler,self__.flag,self__.cb,meta36061__$1));
});

cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36062){
var self__ = this;
var _36062__$1 = this;
return self__.meta36061;
});

cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async36060.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async36060.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_handler,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$cb], null)))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$cb,cljs.core.cst$sym$meta36061], null);
});

cljs.core.async.t_cljs$core$async36060.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36060.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36060";

cljs.core.async.t_cljs$core$async36060.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36060");
});

cljs.core.async.__GT_t_cljs$core$async36060 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async36060(alt_handler__$1,flag__$1,cb__$1,meta36061){
return (new cljs.core.async.t_cljs$core$async36060(alt_handler__$1,flag__$1,cb__$1,meta36061));
});

}

return (new cljs.core.async.t_cljs$core$async36060(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = cljs.core.cst$kw$priority.cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__36063_SHARP_){
var G__36067 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__36063_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__36067) : fret.call(null,G__36067));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__36064_SHARP_){
var G__36068 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__36064_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__36068) : fret.call(null,G__36068));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(vbox) : cljs.core.deref.call(null,vbox)),(function (){var or__4682__auto__ = wport;
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
return port;
}
})()], null));
} else {
var G__36069 = (i + (1));
i = G__36069;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4682__auto__ = ret;
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,cljs.core.cst$kw$default)){
var temp__4653__auto__ = (function (){var and__4670__auto__ = cljs.core.async.impl.protocols.active_QMARK_(flag);
if(cljs.core.truth_(and__4670__auto__)){
return cljs.core.async.impl.protocols.commit(flag);
} else {
return and__4670__auto__;
}
})();
if(cljs.core.truth_(temp__4653__auto__)){
var got = temp__4653__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$default.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$default], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__5747__auto__ = [];
var len__5740__auto___36075 = arguments.length;
var i__5741__auto___36076 = (0);
while(true){
if((i__5741__auto___36076 < len__5740__auto___36075)){
args__5747__auto__.push((arguments[i__5741__auto___36076]));

var G__36077 = (i__5741__auto___36076 + (1));
i__5741__auto___36076 = G__36077;
continue;
} else {
}
break;
}

var argseq__5748__auto__ = ((((1) < args__5747__auto__.length))?(new cljs.core.IndexedSeq(args__5747__auto__.slice((1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5748__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__36072){
var map__36073 = p__36072;
var map__36073__$1 = ((((!((map__36073 == null)))?((((map__36073.cljs$lang$protocol_mask$partition0$ & (64))) || (map__36073.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__36073):map__36073);
var opts = map__36073__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq36070){
var G__36071 = cljs.core.first(seq36070);
var seq36070__$1 = cljs.core.next(seq36070);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__36071,seq36070__$1);
});
/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args36078 = [];
var len__5740__auto___36128 = arguments.length;
var i__5741__auto___36129 = (0);
while(true){
if((i__5741__auto___36129 < len__5740__auto___36128)){
args36078.push((arguments[i__5741__auto___36129]));

var G__36130 = (i__5741__auto___36129 + (1));
i__5741__auto___36129 = G__36130;
continue;
} else {
}
break;
}

var G__36080 = args36078.length;
switch (G__36080) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36078.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__35961__auto___36132 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___36132){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___36132){
return (function (state_36104){
var state_val_36105 = (state_36104[(1)]);
if((state_val_36105 === (7))){
var inst_36100 = (state_36104[(2)]);
var state_36104__$1 = state_36104;
var statearr_36106_36133 = state_36104__$1;
(statearr_36106_36133[(2)] = inst_36100);

(statearr_36106_36133[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (1))){
var state_36104__$1 = state_36104;
var statearr_36107_36134 = state_36104__$1;
(statearr_36107_36134[(2)] = null);

(statearr_36107_36134[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (4))){
var inst_36083 = (state_36104[(7)]);
var inst_36083__$1 = (state_36104[(2)]);
var inst_36084 = (inst_36083__$1 == null);
var state_36104__$1 = (function (){var statearr_36108 = state_36104;
(statearr_36108[(7)] = inst_36083__$1);

return statearr_36108;
})();
if(cljs.core.truth_(inst_36084)){
var statearr_36109_36135 = state_36104__$1;
(statearr_36109_36135[(1)] = (5));

} else {
var statearr_36110_36136 = state_36104__$1;
(statearr_36110_36136[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (13))){
var state_36104__$1 = state_36104;
var statearr_36111_36137 = state_36104__$1;
(statearr_36111_36137[(2)] = null);

(statearr_36111_36137[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (6))){
var inst_36083 = (state_36104[(7)]);
var state_36104__$1 = state_36104;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36104__$1,(11),to,inst_36083);
} else {
if((state_val_36105 === (3))){
var inst_36102 = (state_36104[(2)]);
var state_36104__$1 = state_36104;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36104__$1,inst_36102);
} else {
if((state_val_36105 === (12))){
var state_36104__$1 = state_36104;
var statearr_36112_36138 = state_36104__$1;
(statearr_36112_36138[(2)] = null);

(statearr_36112_36138[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (2))){
var state_36104__$1 = state_36104;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36104__$1,(4),from);
} else {
if((state_val_36105 === (11))){
var inst_36093 = (state_36104[(2)]);
var state_36104__$1 = state_36104;
if(cljs.core.truth_(inst_36093)){
var statearr_36113_36139 = state_36104__$1;
(statearr_36113_36139[(1)] = (12));

} else {
var statearr_36114_36140 = state_36104__$1;
(statearr_36114_36140[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (9))){
var state_36104__$1 = state_36104;
var statearr_36115_36141 = state_36104__$1;
(statearr_36115_36141[(2)] = null);

(statearr_36115_36141[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (5))){
var state_36104__$1 = state_36104;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36116_36142 = state_36104__$1;
(statearr_36116_36142[(1)] = (8));

} else {
var statearr_36117_36143 = state_36104__$1;
(statearr_36117_36143[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (14))){
var inst_36098 = (state_36104[(2)]);
var state_36104__$1 = state_36104;
var statearr_36118_36144 = state_36104__$1;
(statearr_36118_36144[(2)] = inst_36098);

(statearr_36118_36144[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (10))){
var inst_36090 = (state_36104[(2)]);
var state_36104__$1 = state_36104;
var statearr_36119_36145 = state_36104__$1;
(statearr_36119_36145[(2)] = inst_36090);

(statearr_36119_36145[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36105 === (8))){
var inst_36087 = cljs.core.async.close_BANG_(to);
var state_36104__$1 = state_36104;
var statearr_36120_36146 = state_36104__$1;
(statearr_36120_36146[(2)] = inst_36087);

(statearr_36120_36146[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___36132))
;
return ((function (switch__35847__auto__,c__35961__auto___36132){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_36124 = [null,null,null,null,null,null,null,null];
(statearr_36124[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_36124[(1)] = (1));

return statearr_36124;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_36104){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36104);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36125){if((e36125 instanceof Object)){
var ex__35851__auto__ = e36125;
var statearr_36126_36147 = state_36104;
(statearr_36126_36147[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36104);

return cljs.core.cst$kw$recur;
} else {
throw e36125;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36148 = state_36104;
state_36104 = G__36148;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_36104){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_36104);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___36132))
})();
var state__35963__auto__ = (function (){var statearr_36127 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36127[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36132);

return statearr_36127;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___36132))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$pos_QMARK_,cljs.core.cst$sym$n)], 0)))].join('')));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = ((function (jobs,results){
return (function (p__36332){
var vec__36333 = p__36332;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36333,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36333,(1),null);
var job = vec__36333;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__35961__auto___36515 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results){
return (function (state_36338){
var state_val_36339 = (state_36338[(1)]);
if((state_val_36339 === (1))){
var state_36338__$1 = state_36338;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36338__$1,(2),res,v);
} else {
if((state_val_36339 === (2))){
var inst_36335 = (state_36338[(2)]);
var inst_36336 = cljs.core.async.close_BANG_(res);
var state_36338__$1 = (function (){var statearr_36340 = state_36338;
(statearr_36340[(7)] = inst_36335);

return statearr_36340;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_36338__$1,inst_36336);
} else {
return null;
}
}
});})(c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results))
;
return ((function (switch__35847__auto__,c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_36344 = [null,null,null,null,null,null,null,null];
(statearr_36344[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__);

(statearr_36344[(1)] = (1));

return statearr_36344;
});
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1 = (function (state_36338){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36338);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36345){if((e36345 instanceof Object)){
var ex__35851__auto__ = e36345;
var statearr_36346_36516 = state_36338;
(statearr_36346_36516[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36338);

return cljs.core.cst$kw$recur;
} else {
throw e36345;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36517 = state_36338;
state_36338 = G__36517;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = function(state_36338){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1.call(this,state_36338);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results))
})();
var state__35963__auto__ = (function (){var statearr_36347 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36347[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36515);

return statearr_36347;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___36515,res,vec__36333,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__36348){
var vec__36349 = p__36348;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36349,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36349,(1),null);
var job = vec__36349;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results,process))
;
var n__5585__auto___36518 = n;
var __36519 = (0);
while(true){
if((__36519 < n__5585__auto___36518)){
var G__36350_36520 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__36350_36520) {
case "compute":
var c__35961__auto___36522 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36519,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (__36519,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function (state_36363){
var state_val_36364 = (state_36363[(1)]);
if((state_val_36364 === (1))){
var state_36363__$1 = state_36363;
var statearr_36365_36523 = state_36363__$1;
(statearr_36365_36523[(2)] = null);

(statearr_36365_36523[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36364 === (2))){
var state_36363__$1 = state_36363;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36363__$1,(4),jobs);
} else {
if((state_val_36364 === (3))){
var inst_36361 = (state_36363[(2)]);
var state_36363__$1 = state_36363;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36363__$1,inst_36361);
} else {
if((state_val_36364 === (4))){
var inst_36353 = (state_36363[(2)]);
var inst_36354 = process(inst_36353);
var state_36363__$1 = state_36363;
if(cljs.core.truth_(inst_36354)){
var statearr_36366_36524 = state_36363__$1;
(statearr_36366_36524[(1)] = (5));

} else {
var statearr_36367_36525 = state_36363__$1;
(statearr_36367_36525[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36364 === (5))){
var state_36363__$1 = state_36363;
var statearr_36368_36526 = state_36363__$1;
(statearr_36368_36526[(2)] = null);

(statearr_36368_36526[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36364 === (6))){
var state_36363__$1 = state_36363;
var statearr_36369_36527 = state_36363__$1;
(statearr_36369_36527[(2)] = null);

(statearr_36369_36527[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36364 === (7))){
var inst_36359 = (state_36363[(2)]);
var state_36363__$1 = state_36363;
var statearr_36370_36528 = state_36363__$1;
(statearr_36370_36528[(2)] = inst_36359);

(statearr_36370_36528[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__36519,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
;
return ((function (__36519,switch__35847__auto__,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_36374 = [null,null,null,null,null,null,null];
(statearr_36374[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__);

(statearr_36374[(1)] = (1));

return statearr_36374;
});
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1 = (function (state_36363){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36363);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36375){if((e36375 instanceof Object)){
var ex__35851__auto__ = e36375;
var statearr_36376_36529 = state_36363;
(statearr_36376_36529[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36363);

return cljs.core.cst$kw$recur;
} else {
throw e36375;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36530 = state_36363;
state_36363 = G__36530;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = function(state_36363){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1.call(this,state_36363);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__;
})()
;})(__36519,switch__35847__auto__,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
})();
var state__35963__auto__ = (function (){var statearr_36377 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36377[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36522);

return statearr_36377;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(__36519,c__35961__auto___36522,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
);


break;
case "async":
var c__35961__auto___36531 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36519,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (__36519,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function (state_36390){
var state_val_36391 = (state_36390[(1)]);
if((state_val_36391 === (1))){
var state_36390__$1 = state_36390;
var statearr_36392_36532 = state_36390__$1;
(statearr_36392_36532[(2)] = null);

(statearr_36392_36532[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36391 === (2))){
var state_36390__$1 = state_36390;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36390__$1,(4),jobs);
} else {
if((state_val_36391 === (3))){
var inst_36388 = (state_36390[(2)]);
var state_36390__$1 = state_36390;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36390__$1,inst_36388);
} else {
if((state_val_36391 === (4))){
var inst_36380 = (state_36390[(2)]);
var inst_36381 = async(inst_36380);
var state_36390__$1 = state_36390;
if(cljs.core.truth_(inst_36381)){
var statearr_36393_36533 = state_36390__$1;
(statearr_36393_36533[(1)] = (5));

} else {
var statearr_36394_36534 = state_36390__$1;
(statearr_36394_36534[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36391 === (5))){
var state_36390__$1 = state_36390;
var statearr_36395_36535 = state_36390__$1;
(statearr_36395_36535[(2)] = null);

(statearr_36395_36535[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36391 === (6))){
var state_36390__$1 = state_36390;
var statearr_36396_36536 = state_36390__$1;
(statearr_36396_36536[(2)] = null);

(statearr_36396_36536[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36391 === (7))){
var inst_36386 = (state_36390[(2)]);
var state_36390__$1 = state_36390;
var statearr_36397_36537 = state_36390__$1;
(statearr_36397_36537[(2)] = inst_36386);

(statearr_36397_36537[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__36519,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
;
return ((function (__36519,switch__35847__auto__,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_36401 = [null,null,null,null,null,null,null];
(statearr_36401[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__);

(statearr_36401[(1)] = (1));

return statearr_36401;
});
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1 = (function (state_36390){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36390);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36402){if((e36402 instanceof Object)){
var ex__35851__auto__ = e36402;
var statearr_36403_36538 = state_36390;
(statearr_36403_36538[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36390);

return cljs.core.cst$kw$recur;
} else {
throw e36402;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36539 = state_36390;
state_36390 = G__36539;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = function(state_36390){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1.call(this,state_36390);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__;
})()
;})(__36519,switch__35847__auto__,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
})();
var state__35963__auto__ = (function (){var statearr_36404 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36404[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36531);

return statearr_36404;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(__36519,c__35961__auto___36531,G__36350_36520,n__5585__auto___36518,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__36540 = (__36519 + (1));
__36519 = G__36540;
continue;
} else {
}
break;
}

var c__35961__auto___36541 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___36541,jobs,results,process,async){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___36541,jobs,results,process,async){
return (function (state_36426){
var state_val_36427 = (state_36426[(1)]);
if((state_val_36427 === (1))){
var state_36426__$1 = state_36426;
var statearr_36428_36542 = state_36426__$1;
(statearr_36428_36542[(2)] = null);

(statearr_36428_36542[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36427 === (2))){
var state_36426__$1 = state_36426;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36426__$1,(4),from);
} else {
if((state_val_36427 === (3))){
var inst_36424 = (state_36426[(2)]);
var state_36426__$1 = state_36426;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36426__$1,inst_36424);
} else {
if((state_val_36427 === (4))){
var inst_36407 = (state_36426[(7)]);
var inst_36407__$1 = (state_36426[(2)]);
var inst_36408 = (inst_36407__$1 == null);
var state_36426__$1 = (function (){var statearr_36429 = state_36426;
(statearr_36429[(7)] = inst_36407__$1);

return statearr_36429;
})();
if(cljs.core.truth_(inst_36408)){
var statearr_36430_36543 = state_36426__$1;
(statearr_36430_36543[(1)] = (5));

} else {
var statearr_36431_36544 = state_36426__$1;
(statearr_36431_36544[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36427 === (5))){
var inst_36410 = cljs.core.async.close_BANG_(jobs);
var state_36426__$1 = state_36426;
var statearr_36432_36545 = state_36426__$1;
(statearr_36432_36545[(2)] = inst_36410);

(statearr_36432_36545[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36427 === (6))){
var inst_36412 = (state_36426[(8)]);
var inst_36407 = (state_36426[(7)]);
var inst_36412__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_36413 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_36414 = [inst_36407,inst_36412__$1];
var inst_36415 = (new cljs.core.PersistentVector(null,2,(5),inst_36413,inst_36414,null));
var state_36426__$1 = (function (){var statearr_36433 = state_36426;
(statearr_36433[(8)] = inst_36412__$1);

return statearr_36433;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36426__$1,(8),jobs,inst_36415);
} else {
if((state_val_36427 === (7))){
var inst_36422 = (state_36426[(2)]);
var state_36426__$1 = state_36426;
var statearr_36434_36546 = state_36426__$1;
(statearr_36434_36546[(2)] = inst_36422);

(statearr_36434_36546[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36427 === (8))){
var inst_36412 = (state_36426[(8)]);
var inst_36417 = (state_36426[(2)]);
var state_36426__$1 = (function (){var statearr_36435 = state_36426;
(statearr_36435[(9)] = inst_36417);

return statearr_36435;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36426__$1,(9),results,inst_36412);
} else {
if((state_val_36427 === (9))){
var inst_36419 = (state_36426[(2)]);
var state_36426__$1 = (function (){var statearr_36436 = state_36426;
(statearr_36436[(10)] = inst_36419);

return statearr_36436;
})();
var statearr_36437_36547 = state_36426__$1;
(statearr_36437_36547[(2)] = null);

(statearr_36437_36547[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___36541,jobs,results,process,async))
;
return ((function (switch__35847__auto__,c__35961__auto___36541,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_36441 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_36441[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__);

(statearr_36441[(1)] = (1));

return statearr_36441;
});
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1 = (function (state_36426){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36426);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36442){if((e36442 instanceof Object)){
var ex__35851__auto__ = e36442;
var statearr_36443_36548 = state_36426;
(statearr_36443_36548[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36426);

return cljs.core.cst$kw$recur;
} else {
throw e36442;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36549 = state_36426;
state_36426 = G__36549;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = function(state_36426){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1.call(this,state_36426);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___36541,jobs,results,process,async))
})();
var state__35963__auto__ = (function (){var statearr_36444 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36444[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36541);

return statearr_36444;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___36541,jobs,results,process,async))
);


var c__35961__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto__,jobs,results,process,async){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto__,jobs,results,process,async){
return (function (state_36482){
var state_val_36483 = (state_36482[(1)]);
if((state_val_36483 === (7))){
var inst_36478 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
var statearr_36484_36550 = state_36482__$1;
(statearr_36484_36550[(2)] = inst_36478);

(statearr_36484_36550[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (20))){
var state_36482__$1 = state_36482;
var statearr_36485_36551 = state_36482__$1;
(statearr_36485_36551[(2)] = null);

(statearr_36485_36551[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (1))){
var state_36482__$1 = state_36482;
var statearr_36486_36552 = state_36482__$1;
(statearr_36486_36552[(2)] = null);

(statearr_36486_36552[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (4))){
var inst_36447 = (state_36482[(7)]);
var inst_36447__$1 = (state_36482[(2)]);
var inst_36448 = (inst_36447__$1 == null);
var state_36482__$1 = (function (){var statearr_36487 = state_36482;
(statearr_36487[(7)] = inst_36447__$1);

return statearr_36487;
})();
if(cljs.core.truth_(inst_36448)){
var statearr_36488_36553 = state_36482__$1;
(statearr_36488_36553[(1)] = (5));

} else {
var statearr_36489_36554 = state_36482__$1;
(statearr_36489_36554[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (15))){
var inst_36460 = (state_36482[(8)]);
var state_36482__$1 = state_36482;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36482__$1,(18),to,inst_36460);
} else {
if((state_val_36483 === (21))){
var inst_36473 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
var statearr_36490_36555 = state_36482__$1;
(statearr_36490_36555[(2)] = inst_36473);

(statearr_36490_36555[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (13))){
var inst_36475 = (state_36482[(2)]);
var state_36482__$1 = (function (){var statearr_36491 = state_36482;
(statearr_36491[(9)] = inst_36475);

return statearr_36491;
})();
var statearr_36492_36556 = state_36482__$1;
(statearr_36492_36556[(2)] = null);

(statearr_36492_36556[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (6))){
var inst_36447 = (state_36482[(7)]);
var state_36482__$1 = state_36482;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36482__$1,(11),inst_36447);
} else {
if((state_val_36483 === (17))){
var inst_36468 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
if(cljs.core.truth_(inst_36468)){
var statearr_36493_36557 = state_36482__$1;
(statearr_36493_36557[(1)] = (19));

} else {
var statearr_36494_36558 = state_36482__$1;
(statearr_36494_36558[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (3))){
var inst_36480 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36482__$1,inst_36480);
} else {
if((state_val_36483 === (12))){
var inst_36457 = (state_36482[(10)]);
var state_36482__$1 = state_36482;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36482__$1,(14),inst_36457);
} else {
if((state_val_36483 === (2))){
var state_36482__$1 = state_36482;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36482__$1,(4),results);
} else {
if((state_val_36483 === (19))){
var state_36482__$1 = state_36482;
var statearr_36495_36559 = state_36482__$1;
(statearr_36495_36559[(2)] = null);

(statearr_36495_36559[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (11))){
var inst_36457 = (state_36482[(2)]);
var state_36482__$1 = (function (){var statearr_36496 = state_36482;
(statearr_36496[(10)] = inst_36457);

return statearr_36496;
})();
var statearr_36497_36560 = state_36482__$1;
(statearr_36497_36560[(2)] = null);

(statearr_36497_36560[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (9))){
var state_36482__$1 = state_36482;
var statearr_36498_36561 = state_36482__$1;
(statearr_36498_36561[(2)] = null);

(statearr_36498_36561[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (5))){
var state_36482__$1 = state_36482;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36499_36562 = state_36482__$1;
(statearr_36499_36562[(1)] = (8));

} else {
var statearr_36500_36563 = state_36482__$1;
(statearr_36500_36563[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (14))){
var inst_36460 = (state_36482[(8)]);
var inst_36462 = (state_36482[(11)]);
var inst_36460__$1 = (state_36482[(2)]);
var inst_36461 = (inst_36460__$1 == null);
var inst_36462__$1 = cljs.core.not(inst_36461);
var state_36482__$1 = (function (){var statearr_36501 = state_36482;
(statearr_36501[(8)] = inst_36460__$1);

(statearr_36501[(11)] = inst_36462__$1);

return statearr_36501;
})();
if(inst_36462__$1){
var statearr_36502_36564 = state_36482__$1;
(statearr_36502_36564[(1)] = (15));

} else {
var statearr_36503_36565 = state_36482__$1;
(statearr_36503_36565[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (16))){
var inst_36462 = (state_36482[(11)]);
var state_36482__$1 = state_36482;
var statearr_36504_36566 = state_36482__$1;
(statearr_36504_36566[(2)] = inst_36462);

(statearr_36504_36566[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (10))){
var inst_36454 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
var statearr_36505_36567 = state_36482__$1;
(statearr_36505_36567[(2)] = inst_36454);

(statearr_36505_36567[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (18))){
var inst_36465 = (state_36482[(2)]);
var state_36482__$1 = state_36482;
var statearr_36506_36568 = state_36482__$1;
(statearr_36506_36568[(2)] = inst_36465);

(statearr_36506_36568[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36483 === (8))){
var inst_36451 = cljs.core.async.close_BANG_(to);
var state_36482__$1 = state_36482;
var statearr_36507_36569 = state_36482__$1;
(statearr_36507_36569[(2)] = inst_36451);

(statearr_36507_36569[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto__,jobs,results,process,async))
;
return ((function (switch__35847__auto__,c__35961__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_36511 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36511[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__);

(statearr_36511[(1)] = (1));

return statearr_36511;
});
var cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1 = (function (state_36482){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36482);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36512){if((e36512 instanceof Object)){
var ex__35851__auto__ = e36512;
var statearr_36513_36570 = state_36482;
(statearr_36513_36570[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36482);

return cljs.core.cst$kw$recur;
} else {
throw e36512;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36571 = state_36482;
state_36482 = G__36571;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__ = function(state_36482){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1.call(this,state_36482);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto__,jobs,results,process,async))
})();
var state__35963__auto__ = (function (){var statearr_36514 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36514[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto__);

return statearr_36514;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto__,jobs,results,process,async))
);

return c__35961__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args36572 = [];
var len__5740__auto___36575 = arguments.length;
var i__5741__auto___36576 = (0);
while(true){
if((i__5741__auto___36576 < len__5740__auto___36575)){
args36572.push((arguments[i__5741__auto___36576]));

var G__36577 = (i__5741__auto___36576 + (1));
i__5741__auto___36576 = G__36577;
continue;
} else {
}
break;
}

var G__36574 = args36572.length;
switch (G__36574) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36572.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,cljs.core.cst$kw$async);
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args36579 = [];
var len__5740__auto___36582 = arguments.length;
var i__5741__auto___36583 = (0);
while(true){
if((i__5741__auto___36583 < len__5740__auto___36582)){
args36579.push((arguments[i__5741__auto___36583]));

var G__36584 = (i__5741__auto___36583 + (1));
i__5741__auto___36583 = G__36584;
continue;
} else {
}
break;
}

var G__36581 = args36579.length;
switch (G__36581) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36579.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,cljs.core.cst$kw$compute);
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;
/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args36586 = [];
var len__5740__auto___36639 = arguments.length;
var i__5741__auto___36640 = (0);
while(true){
if((i__5741__auto___36640 < len__5740__auto___36639)){
args36586.push((arguments[i__5741__auto___36640]));

var G__36641 = (i__5741__auto___36640 + (1));
i__5741__auto___36640 = G__36641;
continue;
} else {
}
break;
}

var G__36588 = args36586.length;
switch (G__36588) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36586.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__35961__auto___36643 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___36643,tc,fc){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___36643,tc,fc){
return (function (state_36614){
var state_val_36615 = (state_36614[(1)]);
if((state_val_36615 === (7))){
var inst_36610 = (state_36614[(2)]);
var state_36614__$1 = state_36614;
var statearr_36616_36644 = state_36614__$1;
(statearr_36616_36644[(2)] = inst_36610);

(statearr_36616_36644[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (1))){
var state_36614__$1 = state_36614;
var statearr_36617_36645 = state_36614__$1;
(statearr_36617_36645[(2)] = null);

(statearr_36617_36645[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (4))){
var inst_36591 = (state_36614[(7)]);
var inst_36591__$1 = (state_36614[(2)]);
var inst_36592 = (inst_36591__$1 == null);
var state_36614__$1 = (function (){var statearr_36618 = state_36614;
(statearr_36618[(7)] = inst_36591__$1);

return statearr_36618;
})();
if(cljs.core.truth_(inst_36592)){
var statearr_36619_36646 = state_36614__$1;
(statearr_36619_36646[(1)] = (5));

} else {
var statearr_36620_36647 = state_36614__$1;
(statearr_36620_36647[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (13))){
var state_36614__$1 = state_36614;
var statearr_36621_36648 = state_36614__$1;
(statearr_36621_36648[(2)] = null);

(statearr_36621_36648[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (6))){
var inst_36591 = (state_36614[(7)]);
var inst_36597 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_36591) : p.call(null,inst_36591));
var state_36614__$1 = state_36614;
if(cljs.core.truth_(inst_36597)){
var statearr_36622_36649 = state_36614__$1;
(statearr_36622_36649[(1)] = (9));

} else {
var statearr_36623_36650 = state_36614__$1;
(statearr_36623_36650[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (3))){
var inst_36612 = (state_36614[(2)]);
var state_36614__$1 = state_36614;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36614__$1,inst_36612);
} else {
if((state_val_36615 === (12))){
var state_36614__$1 = state_36614;
var statearr_36624_36651 = state_36614__$1;
(statearr_36624_36651[(2)] = null);

(statearr_36624_36651[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (2))){
var state_36614__$1 = state_36614;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36614__$1,(4),ch);
} else {
if((state_val_36615 === (11))){
var inst_36591 = (state_36614[(7)]);
var inst_36601 = (state_36614[(2)]);
var state_36614__$1 = state_36614;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36614__$1,(8),inst_36601,inst_36591);
} else {
if((state_val_36615 === (9))){
var state_36614__$1 = state_36614;
var statearr_36625_36652 = state_36614__$1;
(statearr_36625_36652[(2)] = tc);

(statearr_36625_36652[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (5))){
var inst_36594 = cljs.core.async.close_BANG_(tc);
var inst_36595 = cljs.core.async.close_BANG_(fc);
var state_36614__$1 = (function (){var statearr_36626 = state_36614;
(statearr_36626[(8)] = inst_36594);

return statearr_36626;
})();
var statearr_36627_36653 = state_36614__$1;
(statearr_36627_36653[(2)] = inst_36595);

(statearr_36627_36653[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (14))){
var inst_36608 = (state_36614[(2)]);
var state_36614__$1 = state_36614;
var statearr_36628_36654 = state_36614__$1;
(statearr_36628_36654[(2)] = inst_36608);

(statearr_36628_36654[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (10))){
var state_36614__$1 = state_36614;
var statearr_36629_36655 = state_36614__$1;
(statearr_36629_36655[(2)] = fc);

(statearr_36629_36655[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36615 === (8))){
var inst_36603 = (state_36614[(2)]);
var state_36614__$1 = state_36614;
if(cljs.core.truth_(inst_36603)){
var statearr_36630_36656 = state_36614__$1;
(statearr_36630_36656[(1)] = (12));

} else {
var statearr_36631_36657 = state_36614__$1;
(statearr_36631_36657[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___36643,tc,fc))
;
return ((function (switch__35847__auto__,c__35961__auto___36643,tc,fc){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_36635 = [null,null,null,null,null,null,null,null,null];
(statearr_36635[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_36635[(1)] = (1));

return statearr_36635;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_36614){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36614);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36636){if((e36636 instanceof Object)){
var ex__35851__auto__ = e36636;
var statearr_36637_36658 = state_36614;
(statearr_36637_36658[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36614);

return cljs.core.cst$kw$recur;
} else {
throw e36636;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36659 = state_36614;
state_36614 = G__36659;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_36614){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_36614);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___36643,tc,fc))
})();
var state__35963__auto__ = (function (){var statearr_36638 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36638[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___36643);

return statearr_36638;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___36643,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__35961__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto__){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto__){
return (function (state_36723){
var state_val_36724 = (state_36723[(1)]);
if((state_val_36724 === (7))){
var inst_36719 = (state_36723[(2)]);
var state_36723__$1 = state_36723;
var statearr_36725_36746 = state_36723__$1;
(statearr_36725_36746[(2)] = inst_36719);

(statearr_36725_36746[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (1))){
var inst_36703 = init;
var state_36723__$1 = (function (){var statearr_36726 = state_36723;
(statearr_36726[(7)] = inst_36703);

return statearr_36726;
})();
var statearr_36727_36747 = state_36723__$1;
(statearr_36727_36747[(2)] = null);

(statearr_36727_36747[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (4))){
var inst_36706 = (state_36723[(8)]);
var inst_36706__$1 = (state_36723[(2)]);
var inst_36707 = (inst_36706__$1 == null);
var state_36723__$1 = (function (){var statearr_36728 = state_36723;
(statearr_36728[(8)] = inst_36706__$1);

return statearr_36728;
})();
if(cljs.core.truth_(inst_36707)){
var statearr_36729_36748 = state_36723__$1;
(statearr_36729_36748[(1)] = (5));

} else {
var statearr_36730_36749 = state_36723__$1;
(statearr_36730_36749[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (6))){
var inst_36703 = (state_36723[(7)]);
var inst_36706 = (state_36723[(8)]);
var inst_36710 = (state_36723[(9)]);
var inst_36710__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_36703,inst_36706) : f.call(null,inst_36703,inst_36706));
var inst_36711 = cljs.core.reduced_QMARK_(inst_36710__$1);
var state_36723__$1 = (function (){var statearr_36731 = state_36723;
(statearr_36731[(9)] = inst_36710__$1);

return statearr_36731;
})();
if(inst_36711){
var statearr_36732_36750 = state_36723__$1;
(statearr_36732_36750[(1)] = (8));

} else {
var statearr_36733_36751 = state_36723__$1;
(statearr_36733_36751[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (3))){
var inst_36721 = (state_36723[(2)]);
var state_36723__$1 = state_36723;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36723__$1,inst_36721);
} else {
if((state_val_36724 === (2))){
var state_36723__$1 = state_36723;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36723__$1,(4),ch);
} else {
if((state_val_36724 === (9))){
var inst_36710 = (state_36723[(9)]);
var inst_36703 = inst_36710;
var state_36723__$1 = (function (){var statearr_36734 = state_36723;
(statearr_36734[(7)] = inst_36703);

return statearr_36734;
})();
var statearr_36735_36752 = state_36723__$1;
(statearr_36735_36752[(2)] = null);

(statearr_36735_36752[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (5))){
var inst_36703 = (state_36723[(7)]);
var state_36723__$1 = state_36723;
var statearr_36736_36753 = state_36723__$1;
(statearr_36736_36753[(2)] = inst_36703);

(statearr_36736_36753[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (10))){
var inst_36717 = (state_36723[(2)]);
var state_36723__$1 = state_36723;
var statearr_36737_36754 = state_36723__$1;
(statearr_36737_36754[(2)] = inst_36717);

(statearr_36737_36754[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36724 === (8))){
var inst_36710 = (state_36723[(9)]);
var inst_36713 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(inst_36710) : cljs.core.deref.call(null,inst_36710));
var state_36723__$1 = state_36723;
var statearr_36738_36755 = state_36723__$1;
(statearr_36738_36755[(2)] = inst_36713);

(statearr_36738_36755[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto__))
;
return ((function (switch__35847__auto__,c__35961__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__35848__auto__ = null;
var cljs$core$async$reduce_$_state_machine__35848__auto____0 = (function (){
var statearr_36742 = [null,null,null,null,null,null,null,null,null,null];
(statearr_36742[(0)] = cljs$core$async$reduce_$_state_machine__35848__auto__);

(statearr_36742[(1)] = (1));

return statearr_36742;
});
var cljs$core$async$reduce_$_state_machine__35848__auto____1 = (function (state_36723){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36723);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36743){if((e36743 instanceof Object)){
var ex__35851__auto__ = e36743;
var statearr_36744_36756 = state_36723;
(statearr_36744_36756[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36723);

return cljs.core.cst$kw$recur;
} else {
throw e36743;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36757 = state_36723;
state_36723 = G__36757;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__35848__auto__ = function(state_36723){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__35848__auto____1.call(this,state_36723);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__35848__auto____0;
cljs$core$async$reduce_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__35848__auto____1;
return cljs$core$async$reduce_$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto__))
})();
var state__35963__auto__ = (function (){var statearr_36745 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36745[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto__);

return statearr_36745;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto__))
);

return c__35961__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args36758 = [];
var len__5740__auto___36810 = arguments.length;
var i__5741__auto___36811 = (0);
while(true){
if((i__5741__auto___36811 < len__5740__auto___36810)){
args36758.push((arguments[i__5741__auto___36811]));

var G__36812 = (i__5741__auto___36811 + (1));
i__5741__auto___36811 = G__36812;
continue;
} else {
}
break;
}

var G__36760 = args36758.length;
switch (G__36760) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36758.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__35961__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto__){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto__){
return (function (state_36785){
var state_val_36786 = (state_36785[(1)]);
if((state_val_36786 === (7))){
var inst_36767 = (state_36785[(2)]);
var state_36785__$1 = state_36785;
var statearr_36787_36814 = state_36785__$1;
(statearr_36787_36814[(2)] = inst_36767);

(statearr_36787_36814[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (1))){
var inst_36761 = cljs.core.seq(coll);
var inst_36762 = inst_36761;
var state_36785__$1 = (function (){var statearr_36788 = state_36785;
(statearr_36788[(7)] = inst_36762);

return statearr_36788;
})();
var statearr_36789_36815 = state_36785__$1;
(statearr_36789_36815[(2)] = null);

(statearr_36789_36815[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (4))){
var inst_36762 = (state_36785[(7)]);
var inst_36765 = cljs.core.first(inst_36762);
var state_36785__$1 = state_36785;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36785__$1,(7),ch,inst_36765);
} else {
if((state_val_36786 === (13))){
var inst_36779 = (state_36785[(2)]);
var state_36785__$1 = state_36785;
var statearr_36790_36816 = state_36785__$1;
(statearr_36790_36816[(2)] = inst_36779);

(statearr_36790_36816[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (6))){
var inst_36770 = (state_36785[(2)]);
var state_36785__$1 = state_36785;
if(cljs.core.truth_(inst_36770)){
var statearr_36791_36817 = state_36785__$1;
(statearr_36791_36817[(1)] = (8));

} else {
var statearr_36792_36818 = state_36785__$1;
(statearr_36792_36818[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (3))){
var inst_36783 = (state_36785[(2)]);
var state_36785__$1 = state_36785;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36785__$1,inst_36783);
} else {
if((state_val_36786 === (12))){
var state_36785__$1 = state_36785;
var statearr_36793_36819 = state_36785__$1;
(statearr_36793_36819[(2)] = null);

(statearr_36793_36819[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (2))){
var inst_36762 = (state_36785[(7)]);
var state_36785__$1 = state_36785;
if(cljs.core.truth_(inst_36762)){
var statearr_36794_36820 = state_36785__$1;
(statearr_36794_36820[(1)] = (4));

} else {
var statearr_36795_36821 = state_36785__$1;
(statearr_36795_36821[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (11))){
var inst_36776 = cljs.core.async.close_BANG_(ch);
var state_36785__$1 = state_36785;
var statearr_36796_36822 = state_36785__$1;
(statearr_36796_36822[(2)] = inst_36776);

(statearr_36796_36822[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (9))){
var state_36785__$1 = state_36785;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36797_36823 = state_36785__$1;
(statearr_36797_36823[(1)] = (11));

} else {
var statearr_36798_36824 = state_36785__$1;
(statearr_36798_36824[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (5))){
var inst_36762 = (state_36785[(7)]);
var state_36785__$1 = state_36785;
var statearr_36799_36825 = state_36785__$1;
(statearr_36799_36825[(2)] = inst_36762);

(statearr_36799_36825[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (10))){
var inst_36781 = (state_36785[(2)]);
var state_36785__$1 = state_36785;
var statearr_36800_36826 = state_36785__$1;
(statearr_36800_36826[(2)] = inst_36781);

(statearr_36800_36826[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36786 === (8))){
var inst_36762 = (state_36785[(7)]);
var inst_36772 = cljs.core.next(inst_36762);
var inst_36762__$1 = inst_36772;
var state_36785__$1 = (function (){var statearr_36801 = state_36785;
(statearr_36801[(7)] = inst_36762__$1);

return statearr_36801;
})();
var statearr_36802_36827 = state_36785__$1;
(statearr_36802_36827[(2)] = null);

(statearr_36802_36827[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto__))
;
return ((function (switch__35847__auto__,c__35961__auto__){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_36806 = [null,null,null,null,null,null,null,null];
(statearr_36806[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_36806[(1)] = (1));

return statearr_36806;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_36785){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_36785);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e36807){if((e36807 instanceof Object)){
var ex__35851__auto__ = e36807;
var statearr_36808_36828 = state_36785;
(statearr_36808_36828[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36785);

return cljs.core.cst$kw$recur;
} else {
throw e36807;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__36829 = state_36785;
state_36785 = G__36829;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_36785){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_36785);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto__))
})();
var state__35963__auto__ = (function (){var statearr_36809 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_36809[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto__);

return statearr_36809;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto__))
);

return c__35961__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__5337__auto__ = (((_ == null))?null:_);
var m__5338__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__5338__auto__.call(null,_));
} else {
var m__5338__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(_) : m__5338__auto____$1.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5338__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__5338__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5338__auto____$1.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto__.call(null,m));
} else {
var m__5338__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = (function (){var G__37054 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37054) : cljs.core.atom.call(null,G__37054));
})();
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async37055 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37055 = (function (mult,ch,cs,meta37056){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta37056 = meta37056;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_37057,meta37056__$1){
var self__ = this;
var _37057__$1 = this;
return (new cljs.core.async.t_cljs$core$async37055(self__.mult,self__.ch,self__.cs,meta37056__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_37057){
var self__ = this;
var _37057__$1 = this;
return self__.meta37056;
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37058_37278 = self__.cs;
var G__37059_37279 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37058_37278,G__37059_37279) : cljs.core.reset_BANG_.call(null,G__37058_37278,G__37059_37279));

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$mult,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),cljs.core.cst$sym$ch,cljs.core.cst$sym$cs,cljs.core.cst$sym$meta37056], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async37055.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37055.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37055";

cljs.core.async.t_cljs$core$async37055.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37055");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async37055 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async37055(mult__$1,ch__$1,cs__$1,meta37056){
return (new cljs.core.async.t_cljs$core$async37055(mult__$1,ch__$1,cs__$1,meta37056));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async37055(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__35961__auto___37280 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___37280,cs,m,dchan,dctr,done){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___37280,cs,m,dchan,dctr,done){
return (function (state_37190){
var state_val_37191 = (state_37190[(1)]);
if((state_val_37191 === (7))){
var inst_37186 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37192_37281 = state_37190__$1;
(statearr_37192_37281[(2)] = inst_37186);

(statearr_37192_37281[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (20))){
var inst_37091 = (state_37190[(7)]);
var inst_37101 = cljs.core.first(inst_37091);
var inst_37102 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37101,(0),null);
var inst_37103 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37101,(1),null);
var state_37190__$1 = (function (){var statearr_37193 = state_37190;
(statearr_37193[(8)] = inst_37102);

return statearr_37193;
})();
if(cljs.core.truth_(inst_37103)){
var statearr_37194_37282 = state_37190__$1;
(statearr_37194_37282[(1)] = (22));

} else {
var statearr_37195_37283 = state_37190__$1;
(statearr_37195_37283[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (27))){
var inst_37062 = (state_37190[(9)]);
var inst_37138 = (state_37190[(10)]);
var inst_37133 = (state_37190[(11)]);
var inst_37131 = (state_37190[(12)]);
var inst_37138__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37131,inst_37133);
var inst_37139 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_37138__$1,inst_37062,done);
var state_37190__$1 = (function (){var statearr_37196 = state_37190;
(statearr_37196[(10)] = inst_37138__$1);

return statearr_37196;
})();
if(cljs.core.truth_(inst_37139)){
var statearr_37197_37284 = state_37190__$1;
(statearr_37197_37284[(1)] = (30));

} else {
var statearr_37198_37285 = state_37190__$1;
(statearr_37198_37285[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (1))){
var state_37190__$1 = state_37190;
var statearr_37199_37286 = state_37190__$1;
(statearr_37199_37286[(2)] = null);

(statearr_37199_37286[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (24))){
var inst_37091 = (state_37190[(7)]);
var inst_37108 = (state_37190[(2)]);
var inst_37109 = cljs.core.next(inst_37091);
var inst_37071 = inst_37109;
var inst_37072 = null;
var inst_37073 = (0);
var inst_37074 = (0);
var state_37190__$1 = (function (){var statearr_37200 = state_37190;
(statearr_37200[(13)] = inst_37071);

(statearr_37200[(14)] = inst_37073);

(statearr_37200[(15)] = inst_37074);

(statearr_37200[(16)] = inst_37072);

(statearr_37200[(17)] = inst_37108);

return statearr_37200;
})();
var statearr_37201_37287 = state_37190__$1;
(statearr_37201_37287[(2)] = null);

(statearr_37201_37287[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (39))){
var state_37190__$1 = state_37190;
var statearr_37205_37288 = state_37190__$1;
(statearr_37205_37288[(2)] = null);

(statearr_37205_37288[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (4))){
var inst_37062 = (state_37190[(9)]);
var inst_37062__$1 = (state_37190[(2)]);
var inst_37063 = (inst_37062__$1 == null);
var state_37190__$1 = (function (){var statearr_37206 = state_37190;
(statearr_37206[(9)] = inst_37062__$1);

return statearr_37206;
})();
if(cljs.core.truth_(inst_37063)){
var statearr_37207_37289 = state_37190__$1;
(statearr_37207_37289[(1)] = (5));

} else {
var statearr_37208_37290 = state_37190__$1;
(statearr_37208_37290[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (15))){
var inst_37071 = (state_37190[(13)]);
var inst_37073 = (state_37190[(14)]);
var inst_37074 = (state_37190[(15)]);
var inst_37072 = (state_37190[(16)]);
var inst_37087 = (state_37190[(2)]);
var inst_37088 = (inst_37074 + (1));
var tmp37202 = inst_37071;
var tmp37203 = inst_37073;
var tmp37204 = inst_37072;
var inst_37071__$1 = tmp37202;
var inst_37072__$1 = tmp37204;
var inst_37073__$1 = tmp37203;
var inst_37074__$1 = inst_37088;
var state_37190__$1 = (function (){var statearr_37209 = state_37190;
(statearr_37209[(13)] = inst_37071__$1);

(statearr_37209[(18)] = inst_37087);

(statearr_37209[(14)] = inst_37073__$1);

(statearr_37209[(15)] = inst_37074__$1);

(statearr_37209[(16)] = inst_37072__$1);

return statearr_37209;
})();
var statearr_37210_37291 = state_37190__$1;
(statearr_37210_37291[(2)] = null);

(statearr_37210_37291[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (21))){
var inst_37112 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37214_37292 = state_37190__$1;
(statearr_37214_37292[(2)] = inst_37112);

(statearr_37214_37292[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (31))){
var inst_37138 = (state_37190[(10)]);
var inst_37142 = done(null);
var inst_37143 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_37138);
var state_37190__$1 = (function (){var statearr_37215 = state_37190;
(statearr_37215[(19)] = inst_37142);

return statearr_37215;
})();
var statearr_37216_37293 = state_37190__$1;
(statearr_37216_37293[(2)] = inst_37143);

(statearr_37216_37293[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (32))){
var inst_37132 = (state_37190[(20)]);
var inst_37130 = (state_37190[(21)]);
var inst_37133 = (state_37190[(11)]);
var inst_37131 = (state_37190[(12)]);
var inst_37145 = (state_37190[(2)]);
var inst_37146 = (inst_37133 + (1));
var tmp37211 = inst_37132;
var tmp37212 = inst_37130;
var tmp37213 = inst_37131;
var inst_37130__$1 = tmp37212;
var inst_37131__$1 = tmp37213;
var inst_37132__$1 = tmp37211;
var inst_37133__$1 = inst_37146;
var state_37190__$1 = (function (){var statearr_37217 = state_37190;
(statearr_37217[(20)] = inst_37132__$1);

(statearr_37217[(21)] = inst_37130__$1);

(statearr_37217[(22)] = inst_37145);

(statearr_37217[(11)] = inst_37133__$1);

(statearr_37217[(12)] = inst_37131__$1);

return statearr_37217;
})();
var statearr_37218_37294 = state_37190__$1;
(statearr_37218_37294[(2)] = null);

(statearr_37218_37294[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (40))){
var inst_37158 = (state_37190[(23)]);
var inst_37162 = done(null);
var inst_37163 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_37158);
var state_37190__$1 = (function (){var statearr_37219 = state_37190;
(statearr_37219[(24)] = inst_37162);

return statearr_37219;
})();
var statearr_37220_37295 = state_37190__$1;
(statearr_37220_37295[(2)] = inst_37163);

(statearr_37220_37295[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (33))){
var inst_37149 = (state_37190[(25)]);
var inst_37151 = cljs.core.chunked_seq_QMARK_(inst_37149);
var state_37190__$1 = state_37190;
if(inst_37151){
var statearr_37221_37296 = state_37190__$1;
(statearr_37221_37296[(1)] = (36));

} else {
var statearr_37222_37297 = state_37190__$1;
(statearr_37222_37297[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (13))){
var inst_37081 = (state_37190[(26)]);
var inst_37084 = cljs.core.async.close_BANG_(inst_37081);
var state_37190__$1 = state_37190;
var statearr_37223_37298 = state_37190__$1;
(statearr_37223_37298[(2)] = inst_37084);

(statearr_37223_37298[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (22))){
var inst_37102 = (state_37190[(8)]);
var inst_37105 = cljs.core.async.close_BANG_(inst_37102);
var state_37190__$1 = state_37190;
var statearr_37224_37299 = state_37190__$1;
(statearr_37224_37299[(2)] = inst_37105);

(statearr_37224_37299[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (36))){
var inst_37149 = (state_37190[(25)]);
var inst_37153 = cljs.core.chunk_first(inst_37149);
var inst_37154 = cljs.core.chunk_rest(inst_37149);
var inst_37155 = cljs.core.count(inst_37153);
var inst_37130 = inst_37154;
var inst_37131 = inst_37153;
var inst_37132 = inst_37155;
var inst_37133 = (0);
var state_37190__$1 = (function (){var statearr_37225 = state_37190;
(statearr_37225[(20)] = inst_37132);

(statearr_37225[(21)] = inst_37130);

(statearr_37225[(11)] = inst_37133);

(statearr_37225[(12)] = inst_37131);

return statearr_37225;
})();
var statearr_37226_37300 = state_37190__$1;
(statearr_37226_37300[(2)] = null);

(statearr_37226_37300[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (41))){
var inst_37149 = (state_37190[(25)]);
var inst_37165 = (state_37190[(2)]);
var inst_37166 = cljs.core.next(inst_37149);
var inst_37130 = inst_37166;
var inst_37131 = null;
var inst_37132 = (0);
var inst_37133 = (0);
var state_37190__$1 = (function (){var statearr_37227 = state_37190;
(statearr_37227[(27)] = inst_37165);

(statearr_37227[(20)] = inst_37132);

(statearr_37227[(21)] = inst_37130);

(statearr_37227[(11)] = inst_37133);

(statearr_37227[(12)] = inst_37131);

return statearr_37227;
})();
var statearr_37228_37301 = state_37190__$1;
(statearr_37228_37301[(2)] = null);

(statearr_37228_37301[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (43))){
var state_37190__$1 = state_37190;
var statearr_37229_37302 = state_37190__$1;
(statearr_37229_37302[(2)] = null);

(statearr_37229_37302[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (29))){
var inst_37174 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37230_37303 = state_37190__$1;
(statearr_37230_37303[(2)] = inst_37174);

(statearr_37230_37303[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (44))){
var inst_37183 = (state_37190[(2)]);
var state_37190__$1 = (function (){var statearr_37231 = state_37190;
(statearr_37231[(28)] = inst_37183);

return statearr_37231;
})();
var statearr_37232_37304 = state_37190__$1;
(statearr_37232_37304[(2)] = null);

(statearr_37232_37304[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (6))){
var inst_37122 = (state_37190[(29)]);
var inst_37121 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_37122__$1 = cljs.core.keys(inst_37121);
var inst_37123 = cljs.core.count(inst_37122__$1);
var inst_37124 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,inst_37123) : cljs.core.reset_BANG_.call(null,dctr,inst_37123));
var inst_37129 = cljs.core.seq(inst_37122__$1);
var inst_37130 = inst_37129;
var inst_37131 = null;
var inst_37132 = (0);
var inst_37133 = (0);
var state_37190__$1 = (function (){var statearr_37233 = state_37190;
(statearr_37233[(30)] = inst_37124);

(statearr_37233[(20)] = inst_37132);

(statearr_37233[(21)] = inst_37130);

(statearr_37233[(29)] = inst_37122__$1);

(statearr_37233[(11)] = inst_37133);

(statearr_37233[(12)] = inst_37131);

return statearr_37233;
})();
var statearr_37234_37305 = state_37190__$1;
(statearr_37234_37305[(2)] = null);

(statearr_37234_37305[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (28))){
var inst_37149 = (state_37190[(25)]);
var inst_37130 = (state_37190[(21)]);
var inst_37149__$1 = cljs.core.seq(inst_37130);
var state_37190__$1 = (function (){var statearr_37235 = state_37190;
(statearr_37235[(25)] = inst_37149__$1);

return statearr_37235;
})();
if(inst_37149__$1){
var statearr_37236_37306 = state_37190__$1;
(statearr_37236_37306[(1)] = (33));

} else {
var statearr_37237_37307 = state_37190__$1;
(statearr_37237_37307[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (25))){
var inst_37132 = (state_37190[(20)]);
var inst_37133 = (state_37190[(11)]);
var inst_37135 = (inst_37133 < inst_37132);
var inst_37136 = inst_37135;
var state_37190__$1 = state_37190;
if(cljs.core.truth_(inst_37136)){
var statearr_37238_37308 = state_37190__$1;
(statearr_37238_37308[(1)] = (27));

} else {
var statearr_37239_37309 = state_37190__$1;
(statearr_37239_37309[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (34))){
var state_37190__$1 = state_37190;
var statearr_37240_37310 = state_37190__$1;
(statearr_37240_37310[(2)] = null);

(statearr_37240_37310[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (17))){
var state_37190__$1 = state_37190;
var statearr_37241_37311 = state_37190__$1;
(statearr_37241_37311[(2)] = null);

(statearr_37241_37311[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (3))){
var inst_37188 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37190__$1,inst_37188);
} else {
if((state_val_37191 === (12))){
var inst_37117 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37242_37312 = state_37190__$1;
(statearr_37242_37312[(2)] = inst_37117);

(statearr_37242_37312[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (2))){
var state_37190__$1 = state_37190;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37190__$1,(4),ch);
} else {
if((state_val_37191 === (23))){
var state_37190__$1 = state_37190;
var statearr_37243_37313 = state_37190__$1;
(statearr_37243_37313[(2)] = null);

(statearr_37243_37313[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (35))){
var inst_37172 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37244_37314 = state_37190__$1;
(statearr_37244_37314[(2)] = inst_37172);

(statearr_37244_37314[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (19))){
var inst_37091 = (state_37190[(7)]);
var inst_37095 = cljs.core.chunk_first(inst_37091);
var inst_37096 = cljs.core.chunk_rest(inst_37091);
var inst_37097 = cljs.core.count(inst_37095);
var inst_37071 = inst_37096;
var inst_37072 = inst_37095;
var inst_37073 = inst_37097;
var inst_37074 = (0);
var state_37190__$1 = (function (){var statearr_37245 = state_37190;
(statearr_37245[(13)] = inst_37071);

(statearr_37245[(14)] = inst_37073);

(statearr_37245[(15)] = inst_37074);

(statearr_37245[(16)] = inst_37072);

return statearr_37245;
})();
var statearr_37246_37315 = state_37190__$1;
(statearr_37246_37315[(2)] = null);

(statearr_37246_37315[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (11))){
var inst_37071 = (state_37190[(13)]);
var inst_37091 = (state_37190[(7)]);
var inst_37091__$1 = cljs.core.seq(inst_37071);
var state_37190__$1 = (function (){var statearr_37247 = state_37190;
(statearr_37247[(7)] = inst_37091__$1);

return statearr_37247;
})();
if(inst_37091__$1){
var statearr_37248_37316 = state_37190__$1;
(statearr_37248_37316[(1)] = (16));

} else {
var statearr_37249_37317 = state_37190__$1;
(statearr_37249_37317[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (9))){
var inst_37119 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37250_37318 = state_37190__$1;
(statearr_37250_37318[(2)] = inst_37119);

(statearr_37250_37318[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (5))){
var inst_37069 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_37070 = cljs.core.seq(inst_37069);
var inst_37071 = inst_37070;
var inst_37072 = null;
var inst_37073 = (0);
var inst_37074 = (0);
var state_37190__$1 = (function (){var statearr_37251 = state_37190;
(statearr_37251[(13)] = inst_37071);

(statearr_37251[(14)] = inst_37073);

(statearr_37251[(15)] = inst_37074);

(statearr_37251[(16)] = inst_37072);

return statearr_37251;
})();
var statearr_37252_37319 = state_37190__$1;
(statearr_37252_37319[(2)] = null);

(statearr_37252_37319[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (14))){
var state_37190__$1 = state_37190;
var statearr_37253_37320 = state_37190__$1;
(statearr_37253_37320[(2)] = null);

(statearr_37253_37320[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (45))){
var inst_37180 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37254_37321 = state_37190__$1;
(statearr_37254_37321[(2)] = inst_37180);

(statearr_37254_37321[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (26))){
var inst_37122 = (state_37190[(29)]);
var inst_37176 = (state_37190[(2)]);
var inst_37177 = cljs.core.seq(inst_37122);
var state_37190__$1 = (function (){var statearr_37255 = state_37190;
(statearr_37255[(31)] = inst_37176);

return statearr_37255;
})();
if(inst_37177){
var statearr_37256_37322 = state_37190__$1;
(statearr_37256_37322[(1)] = (42));

} else {
var statearr_37257_37323 = state_37190__$1;
(statearr_37257_37323[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (16))){
var inst_37091 = (state_37190[(7)]);
var inst_37093 = cljs.core.chunked_seq_QMARK_(inst_37091);
var state_37190__$1 = state_37190;
if(inst_37093){
var statearr_37258_37324 = state_37190__$1;
(statearr_37258_37324[(1)] = (19));

} else {
var statearr_37259_37325 = state_37190__$1;
(statearr_37259_37325[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (38))){
var inst_37169 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37260_37326 = state_37190__$1;
(statearr_37260_37326[(2)] = inst_37169);

(statearr_37260_37326[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (30))){
var state_37190__$1 = state_37190;
var statearr_37261_37327 = state_37190__$1;
(statearr_37261_37327[(2)] = null);

(statearr_37261_37327[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (10))){
var inst_37074 = (state_37190[(15)]);
var inst_37072 = (state_37190[(16)]);
var inst_37080 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37072,inst_37074);
var inst_37081 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37080,(0),null);
var inst_37082 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37080,(1),null);
var state_37190__$1 = (function (){var statearr_37262 = state_37190;
(statearr_37262[(26)] = inst_37081);

return statearr_37262;
})();
if(cljs.core.truth_(inst_37082)){
var statearr_37263_37328 = state_37190__$1;
(statearr_37263_37328[(1)] = (13));

} else {
var statearr_37264_37329 = state_37190__$1;
(statearr_37264_37329[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (18))){
var inst_37115 = (state_37190[(2)]);
var state_37190__$1 = state_37190;
var statearr_37265_37330 = state_37190__$1;
(statearr_37265_37330[(2)] = inst_37115);

(statearr_37265_37330[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (42))){
var state_37190__$1 = state_37190;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37190__$1,(45),dchan);
} else {
if((state_val_37191 === (37))){
var inst_37062 = (state_37190[(9)]);
var inst_37149 = (state_37190[(25)]);
var inst_37158 = (state_37190[(23)]);
var inst_37158__$1 = cljs.core.first(inst_37149);
var inst_37159 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_37158__$1,inst_37062,done);
var state_37190__$1 = (function (){var statearr_37266 = state_37190;
(statearr_37266[(23)] = inst_37158__$1);

return statearr_37266;
})();
if(cljs.core.truth_(inst_37159)){
var statearr_37267_37331 = state_37190__$1;
(statearr_37267_37331[(1)] = (39));

} else {
var statearr_37268_37332 = state_37190__$1;
(statearr_37268_37332[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37191 === (8))){
var inst_37073 = (state_37190[(14)]);
var inst_37074 = (state_37190[(15)]);
var inst_37076 = (inst_37074 < inst_37073);
var inst_37077 = inst_37076;
var state_37190__$1 = state_37190;
if(cljs.core.truth_(inst_37077)){
var statearr_37269_37333 = state_37190__$1;
(statearr_37269_37333[(1)] = (10));

} else {
var statearr_37270_37334 = state_37190__$1;
(statearr_37270_37334[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___37280,cs,m,dchan,dctr,done))
;
return ((function (switch__35847__auto__,c__35961__auto___37280,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__35848__auto__ = null;
var cljs$core$async$mult_$_state_machine__35848__auto____0 = (function (){
var statearr_37274 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37274[(0)] = cljs$core$async$mult_$_state_machine__35848__auto__);

(statearr_37274[(1)] = (1));

return statearr_37274;
});
var cljs$core$async$mult_$_state_machine__35848__auto____1 = (function (state_37190){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_37190);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e37275){if((e37275 instanceof Object)){
var ex__35851__auto__ = e37275;
var statearr_37276_37335 = state_37190;
(statearr_37276_37335[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37190);

return cljs.core.cst$kw$recur;
} else {
throw e37275;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__37336 = state_37190;
state_37190 = G__37336;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__35848__auto__ = function(state_37190){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__35848__auto____1.call(this,state_37190);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__35848__auto____0;
cljs$core$async$mult_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__35848__auto____1;
return cljs$core$async$mult_$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___37280,cs,m,dchan,dctr,done))
})();
var state__35963__auto__ = (function (){var statearr_37277 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_37277[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___37280);

return statearr_37277;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___37280,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args37337 = [];
var len__5740__auto___37340 = arguments.length;
var i__5741__auto___37341 = (0);
while(true){
if((i__5741__auto___37341 < len__5740__auto___37340)){
args37337.push((arguments[i__5741__auto___37341]));

var G__37342 = (i__5741__auto___37341 + (1));
i__5741__auto___37341 = G__37342;
continue;
} else {
}
break;
}

var G__37339 = args37337.length;
switch (G__37339) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37337.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto__.call(null,m));
} else {
var m__5338__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5338__auto__.call(null,m,state_map));
} else {
var m__5338__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5338__auto____$1.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5338__auto__.call(null,m,mode));
} else {
var m__5338__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5338__auto____$1.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__5747__auto__ = [];
var len__5740__auto___37354 = arguments.length;
var i__5741__auto___37355 = (0);
while(true){
if((i__5741__auto___37355 < len__5740__auto___37354)){
args__5747__auto__.push((arguments[i__5741__auto___37355]));

var G__37356 = (i__5741__auto___37355 + (1));
i__5741__auto___37355 = G__37356;
continue;
} else {
}
break;
}

var argseq__5748__auto__ = ((((3) < args__5747__auto__.length))?(new cljs.core.IndexedSeq(args__5747__auto__.slice((3)),(0))):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5748__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__37348){
var map__37349 = p__37348;
var map__37349__$1 = ((((!((map__37349 == null)))?((((map__37349.cljs$lang$protocol_mask$partition0$ & (64))) || (map__37349.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__37349):map__37349);
var opts = map__37349__$1;
var statearr_37351_37357 = state;
(statearr_37351_37357[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4653__auto__ = cljs.core.async.do_alts(((function (map__37349,map__37349__$1,opts){
return (function (val){
var statearr_37352_37358 = state;
(statearr_37352_37358[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
});})(map__37349,map__37349__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4653__auto__)){
var cb = temp__4653__auto__;
var statearr_37353_37359 = state;
(statearr_37353_37359[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cb) : cljs.core.deref.call(null,cb)));


return cljs.core.cst$kw$recur;
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq37344){
var G__37345 = cljs.core.first(seq37344);
var seq37344__$1 = cljs.core.next(seq37344);
var G__37346 = cljs.core.first(seq37344__$1);
var seq37344__$2 = cljs.core.next(seq37344__$1);
var G__37347 = cljs.core.first(seq37344__$2);
var seq37344__$3 = cljs.core.next(seq37344__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__37345,G__37346,G__37347,seq37344__$3);
});
/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = (function (){var G__37526 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37526) : cljs.core.atom.call(null,G__37526));
})();
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$pause,null,cljs.core.cst$kw$mute,null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,cljs.core.cst$kw$solo);
var solo_mode = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$mute) : cljs.core.atom.call(null,cljs.core.cst$kw$mute));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var mode = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(solo_mode) : cljs.core.deref.call(null,solo_mode));
var solos = pick(cljs.core.cst$kw$solo,chs);
var pauses = pick(cljs.core.cst$kw$pause,chs);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$solos,solos,cljs.core.cst$kw$mutes,pick(cljs.core.cst$kw$mute,chs),cljs.core.cst$kw$reads,cljs.core.conj.cljs$core$IFn$_invoke$arity$2((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,cljs.core.cst$kw$pause)) && (!(cljs.core.empty_QMARK_(solos))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async37527 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37527 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta37528){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta37528 = meta37528;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_37529,meta37528__$1){
var self__ = this;
var _37529__$1 = this;
return (new cljs.core.async.t_cljs$core$async37527(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta37528__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_37529){
var self__ = this;
var _37529__$1 = this;
return self__.meta37528;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37530_37692 = self__.cs;
var G__37531_37693 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37530_37692,G__37531_37693) : cljs.core.reset_BANG_.call(null,G__37530_37692,G__37531_37693));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$mode)], 0)))].join('')));
}

(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.solo_mode,mode) : cljs.core.reset_BANG_.call(null,self__.solo_mode,mode));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$change,cljs.core.with_meta(cljs.core.cst$sym$mix,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$out], null))),cljs.core.cst$kw$doc,"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),cljs.core.cst$sym$solo_DASH_mode,cljs.core.cst$sym$pick,cljs.core.cst$sym$cs,cljs.core.cst$sym$calc_DASH_state,cljs.core.cst$sym$out,cljs.core.cst$sym$changed,cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$attrs,cljs.core.cst$sym$meta37528], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37527.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37527.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37527";

cljs.core.async.t_cljs$core$async37527.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37527");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async37527 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async37527(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta37528){
return (new cljs.core.async.t_cljs$core$async37527(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta37528));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async37527(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__35961__auto___37694 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_37629){
var state_val_37630 = (state_37629[(1)]);
if((state_val_37630 === (7))){
var inst_37547 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
var statearr_37631_37695 = state_37629__$1;
(statearr_37631_37695[(2)] = inst_37547);

(statearr_37631_37695[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (20))){
var inst_37559 = (state_37629[(7)]);
var state_37629__$1 = state_37629;
var statearr_37632_37696 = state_37629__$1;
(statearr_37632_37696[(2)] = inst_37559);

(statearr_37632_37696[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (27))){
var state_37629__$1 = state_37629;
var statearr_37633_37697 = state_37629__$1;
(statearr_37633_37697[(2)] = null);

(statearr_37633_37697[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (1))){
var inst_37535 = (state_37629[(8)]);
var inst_37535__$1 = calc_state();
var inst_37537 = (inst_37535__$1 == null);
var inst_37538 = cljs.core.not(inst_37537);
var state_37629__$1 = (function (){var statearr_37634 = state_37629;
(statearr_37634[(8)] = inst_37535__$1);

return statearr_37634;
})();
if(inst_37538){
var statearr_37635_37698 = state_37629__$1;
(statearr_37635_37698[(1)] = (2));

} else {
var statearr_37636_37699 = state_37629__$1;
(statearr_37636_37699[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (24))){
var inst_37582 = (state_37629[(9)]);
var inst_37603 = (state_37629[(10)]);
var inst_37589 = (state_37629[(11)]);
var inst_37603__$1 = (inst_37582.cljs$core$IFn$_invoke$arity$1 ? inst_37582.cljs$core$IFn$_invoke$arity$1(inst_37589) : inst_37582.call(null,inst_37589));
var state_37629__$1 = (function (){var statearr_37637 = state_37629;
(statearr_37637[(10)] = inst_37603__$1);

return statearr_37637;
})();
if(cljs.core.truth_(inst_37603__$1)){
var statearr_37638_37700 = state_37629__$1;
(statearr_37638_37700[(1)] = (29));

} else {
var statearr_37639_37701 = state_37629__$1;
(statearr_37639_37701[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (4))){
var inst_37550 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37550)){
var statearr_37640_37702 = state_37629__$1;
(statearr_37640_37702[(1)] = (8));

} else {
var statearr_37641_37703 = state_37629__$1;
(statearr_37641_37703[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (15))){
var inst_37576 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37576)){
var statearr_37642_37704 = state_37629__$1;
(statearr_37642_37704[(1)] = (19));

} else {
var statearr_37643_37705 = state_37629__$1;
(statearr_37643_37705[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (21))){
var inst_37581 = (state_37629[(12)]);
var inst_37581__$1 = (state_37629[(2)]);
var inst_37582 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37581__$1,cljs.core.cst$kw$solos);
var inst_37583 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37581__$1,cljs.core.cst$kw$mutes);
var inst_37584 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37581__$1,cljs.core.cst$kw$reads);
var state_37629__$1 = (function (){var statearr_37644 = state_37629;
(statearr_37644[(9)] = inst_37582);

(statearr_37644[(13)] = inst_37583);

(statearr_37644[(12)] = inst_37581__$1);

return statearr_37644;
})();
return cljs.core.async.ioc_alts_BANG_(state_37629__$1,(22),inst_37584);
} else {
if((state_val_37630 === (31))){
var inst_37611 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37611)){
var statearr_37645_37706 = state_37629__$1;
(statearr_37645_37706[(1)] = (32));

} else {
var statearr_37646_37707 = state_37629__$1;
(statearr_37646_37707[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (32))){
var inst_37588 = (state_37629[(14)]);
var state_37629__$1 = state_37629;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37629__$1,(35),out,inst_37588);
} else {
if((state_val_37630 === (33))){
var inst_37581 = (state_37629[(12)]);
var inst_37559 = inst_37581;
var state_37629__$1 = (function (){var statearr_37647 = state_37629;
(statearr_37647[(7)] = inst_37559);

return statearr_37647;
})();
var statearr_37648_37708 = state_37629__$1;
(statearr_37648_37708[(2)] = null);

(statearr_37648_37708[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (13))){
var inst_37559 = (state_37629[(7)]);
var inst_37566 = inst_37559.cljs$lang$protocol_mask$partition0$;
var inst_37567 = (inst_37566 & (64));
var inst_37568 = inst_37559.cljs$core$ISeq$;
var inst_37569 = (inst_37567) || (inst_37568);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37569)){
var statearr_37649_37709 = state_37629__$1;
(statearr_37649_37709[(1)] = (16));

} else {
var statearr_37650_37710 = state_37629__$1;
(statearr_37650_37710[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (22))){
var inst_37588 = (state_37629[(14)]);
var inst_37589 = (state_37629[(11)]);
var inst_37587 = (state_37629[(2)]);
var inst_37588__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37587,(0),null);
var inst_37589__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37587,(1),null);
var inst_37590 = (inst_37588__$1 == null);
var inst_37591 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_37589__$1,change);
var inst_37592 = (inst_37590) || (inst_37591);
var state_37629__$1 = (function (){var statearr_37651 = state_37629;
(statearr_37651[(14)] = inst_37588__$1);

(statearr_37651[(11)] = inst_37589__$1);

return statearr_37651;
})();
if(cljs.core.truth_(inst_37592)){
var statearr_37652_37711 = state_37629__$1;
(statearr_37652_37711[(1)] = (23));

} else {
var statearr_37653_37712 = state_37629__$1;
(statearr_37653_37712[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (36))){
var inst_37581 = (state_37629[(12)]);
var inst_37559 = inst_37581;
var state_37629__$1 = (function (){var statearr_37654 = state_37629;
(statearr_37654[(7)] = inst_37559);

return statearr_37654;
})();
var statearr_37655_37713 = state_37629__$1;
(statearr_37655_37713[(2)] = null);

(statearr_37655_37713[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (29))){
var inst_37603 = (state_37629[(10)]);
var state_37629__$1 = state_37629;
var statearr_37656_37714 = state_37629__$1;
(statearr_37656_37714[(2)] = inst_37603);

(statearr_37656_37714[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (6))){
var state_37629__$1 = state_37629;
var statearr_37657_37715 = state_37629__$1;
(statearr_37657_37715[(2)] = false);

(statearr_37657_37715[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (28))){
var inst_37599 = (state_37629[(2)]);
var inst_37600 = calc_state();
var inst_37559 = inst_37600;
var state_37629__$1 = (function (){var statearr_37658 = state_37629;
(statearr_37658[(15)] = inst_37599);

(statearr_37658[(7)] = inst_37559);

return statearr_37658;
})();
var statearr_37659_37716 = state_37629__$1;
(statearr_37659_37716[(2)] = null);

(statearr_37659_37716[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (25))){
var inst_37625 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
var statearr_37660_37717 = state_37629__$1;
(statearr_37660_37717[(2)] = inst_37625);

(statearr_37660_37717[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (34))){
var inst_37623 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
var statearr_37661_37718 = state_37629__$1;
(statearr_37661_37718[(2)] = inst_37623);

(statearr_37661_37718[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (17))){
var state_37629__$1 = state_37629;
var statearr_37662_37719 = state_37629__$1;
(statearr_37662_37719[(2)] = false);

(statearr_37662_37719[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (3))){
var state_37629__$1 = state_37629;
var statearr_37663_37720 = state_37629__$1;
(statearr_37663_37720[(2)] = false);

(statearr_37663_37720[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (12))){
var inst_37627 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37629__$1,inst_37627);
} else {
if((state_val_37630 === (2))){
var inst_37535 = (state_37629[(8)]);
var inst_37540 = inst_37535.cljs$lang$protocol_mask$partition0$;
var inst_37541 = (inst_37540 & (64));
var inst_37542 = inst_37535.cljs$core$ISeq$;
var inst_37543 = (inst_37541) || (inst_37542);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37543)){
var statearr_37664_37721 = state_37629__$1;
(statearr_37664_37721[(1)] = (5));

} else {
var statearr_37665_37722 = state_37629__$1;
(statearr_37665_37722[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (23))){
var inst_37588 = (state_37629[(14)]);
var inst_37594 = (inst_37588 == null);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37594)){
var statearr_37666_37723 = state_37629__$1;
(statearr_37666_37723[(1)] = (26));

} else {
var statearr_37667_37724 = state_37629__$1;
(statearr_37667_37724[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (35))){
var inst_37614 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
if(cljs.core.truth_(inst_37614)){
var statearr_37668_37725 = state_37629__$1;
(statearr_37668_37725[(1)] = (36));

} else {
var statearr_37669_37726 = state_37629__$1;
(statearr_37669_37726[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (19))){
var inst_37559 = (state_37629[(7)]);
var inst_37578 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_37559);
var state_37629__$1 = state_37629;
var statearr_37670_37727 = state_37629__$1;
(statearr_37670_37727[(2)] = inst_37578);

(statearr_37670_37727[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (11))){
var inst_37559 = (state_37629[(7)]);
var inst_37563 = (inst_37559 == null);
var inst_37564 = cljs.core.not(inst_37563);
var state_37629__$1 = state_37629;
if(inst_37564){
var statearr_37671_37728 = state_37629__$1;
(statearr_37671_37728[(1)] = (13));

} else {
var statearr_37672_37729 = state_37629__$1;
(statearr_37672_37729[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (9))){
var inst_37535 = (state_37629[(8)]);
var state_37629__$1 = state_37629;
var statearr_37673_37730 = state_37629__$1;
(statearr_37673_37730[(2)] = inst_37535);

(statearr_37673_37730[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (5))){
var state_37629__$1 = state_37629;
var statearr_37674_37731 = state_37629__$1;
(statearr_37674_37731[(2)] = true);

(statearr_37674_37731[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (14))){
var state_37629__$1 = state_37629;
var statearr_37675_37732 = state_37629__$1;
(statearr_37675_37732[(2)] = false);

(statearr_37675_37732[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (26))){
var inst_37589 = (state_37629[(11)]);
var inst_37596 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_37589);
var state_37629__$1 = state_37629;
var statearr_37676_37733 = state_37629__$1;
(statearr_37676_37733[(2)] = inst_37596);

(statearr_37676_37733[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (16))){
var state_37629__$1 = state_37629;
var statearr_37677_37734 = state_37629__$1;
(statearr_37677_37734[(2)] = true);

(statearr_37677_37734[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (38))){
var inst_37619 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
var statearr_37678_37735 = state_37629__$1;
(statearr_37678_37735[(2)] = inst_37619);

(statearr_37678_37735[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (30))){
var inst_37582 = (state_37629[(9)]);
var inst_37583 = (state_37629[(13)]);
var inst_37589 = (state_37629[(11)]);
var inst_37606 = cljs.core.empty_QMARK_(inst_37582);
var inst_37607 = (inst_37583.cljs$core$IFn$_invoke$arity$1 ? inst_37583.cljs$core$IFn$_invoke$arity$1(inst_37589) : inst_37583.call(null,inst_37589));
var inst_37608 = cljs.core.not(inst_37607);
var inst_37609 = (inst_37606) && (inst_37608);
var state_37629__$1 = state_37629;
var statearr_37679_37736 = state_37629__$1;
(statearr_37679_37736[(2)] = inst_37609);

(statearr_37679_37736[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (10))){
var inst_37535 = (state_37629[(8)]);
var inst_37555 = (state_37629[(2)]);
var inst_37556 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37555,cljs.core.cst$kw$solos);
var inst_37557 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37555,cljs.core.cst$kw$mutes);
var inst_37558 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37555,cljs.core.cst$kw$reads);
var inst_37559 = inst_37535;
var state_37629__$1 = (function (){var statearr_37680 = state_37629;
(statearr_37680[(16)] = inst_37556);

(statearr_37680[(17)] = inst_37557);

(statearr_37680[(18)] = inst_37558);

(statearr_37680[(7)] = inst_37559);

return statearr_37680;
})();
var statearr_37681_37737 = state_37629__$1;
(statearr_37681_37737[(2)] = null);

(statearr_37681_37737[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (18))){
var inst_37573 = (state_37629[(2)]);
var state_37629__$1 = state_37629;
var statearr_37682_37738 = state_37629__$1;
(statearr_37682_37738[(2)] = inst_37573);

(statearr_37682_37738[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (37))){
var state_37629__$1 = state_37629;
var statearr_37683_37739 = state_37629__$1;
(statearr_37683_37739[(2)] = null);

(statearr_37683_37739[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37630 === (8))){
var inst_37535 = (state_37629[(8)]);
var inst_37552 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_37535);
var state_37629__$1 = state_37629;
var statearr_37684_37740 = state_37629__$1;
(statearr_37684_37740[(2)] = inst_37552);

(statearr_37684_37740[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__35847__auto__,c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__35848__auto__ = null;
var cljs$core$async$mix_$_state_machine__35848__auto____0 = (function (){
var statearr_37688 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37688[(0)] = cljs$core$async$mix_$_state_machine__35848__auto__);

(statearr_37688[(1)] = (1));

return statearr_37688;
});
var cljs$core$async$mix_$_state_machine__35848__auto____1 = (function (state_37629){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_37629);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e37689){if((e37689 instanceof Object)){
var ex__35851__auto__ = e37689;
var statearr_37690_37741 = state_37629;
(statearr_37690_37741[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37629);

return cljs.core.cst$kw$recur;
} else {
throw e37689;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__37742 = state_37629;
state_37629 = G__37742;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__35848__auto__ = function(state_37629){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__35848__auto____1.call(this,state_37629);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__35848__auto____0;
cljs$core$async$mix_$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__35848__auto____1;
return cljs$core$async$mix_$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__35963__auto__ = (function (){var statearr_37691 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_37691[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___37694);

return statearr_37691;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___37694,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$4 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5338__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__5338__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$4 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5338__auto____$1.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5338__auto__.call(null,p,v,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5338__auto____$1.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args37743 = [];
var len__5740__auto___37746 = arguments.length;
var i__5741__auto___37747 = (0);
while(true){
if((i__5741__auto___37747 < len__5740__auto___37746)){
args37743.push((arguments[i__5741__auto___37747]));

var G__37748 = (i__5741__auto___37747 + (1));
i__5741__auto___37747 = G__37748;
continue;
} else {
}
break;
}

var G__37745 = args37743.length;
switch (G__37745) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37743.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__5338__auto__.call(null,p));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(p) : m__5338__auto____$1.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__5338__auto__.call(null,p,v));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(p,v) : m__5338__auto____$1.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args37751 = [];
var len__5740__auto___37879 = arguments.length;
var i__5741__auto___37880 = (0);
while(true){
if((i__5741__auto___37880 < len__5740__auto___37879)){
args37751.push((arguments[i__5741__auto___37880]));

var G__37881 = (i__5741__auto___37880 + (1));
i__5741__auto___37880 = G__37881;
continue;
} else {
}
break;
}

var G__37753 = args37751.length;
switch (G__37753) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37751.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = (function (){var G__37754 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37754) : cljs.core.atom.call(null,G__37754));
})();
var ensure_mult = ((function (mults){
return (function (topic){
var or__4682__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults)),topic);
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__4682__auto__,mults){
return (function (p1__37750_SHARP_){
if(cljs.core.truth_((p1__37750_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__37750_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__37750_SHARP_.call(null,topic)))){
return p1__37750_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__37750_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
});})(or__4682__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async37755 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37755 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta37756){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta37756 = meta37756;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_37757,meta37756__$1){
var self__ = this;
var _37757__$1 = this;
return (new cljs.core.async.t_cljs$core$async37755(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta37756__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_37757){
var self__ = this;
var _37757__$1 = this;
return self__.meta37756;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4653__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.mults) : cljs.core.deref.call(null,self__.mults)),topic);
if(cljs.core.truth_(temp__4653__auto__)){
var m = temp__4653__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37758 = self__.mults;
var G__37759 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37758,G__37759) : cljs.core.reset_BANG_.call(null,G__37758,G__37759));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$topic_DASH_fn,cljs.core.cst$sym$buf_DASH_fn,cljs.core.cst$sym$mults,cljs.core.cst$sym$ensure_DASH_mult,cljs.core.cst$sym$meta37756], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37755.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37755.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37755";

cljs.core.async.t_cljs$core$async37755.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37755");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async37755 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async37755(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta37756){
return (new cljs.core.async.t_cljs$core$async37755(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta37756));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async37755(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__35961__auto___37883 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___37883,mults,ensure_mult,p){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___37883,mults,ensure_mult,p){
return (function (state_37831){
var state_val_37832 = (state_37831[(1)]);
if((state_val_37832 === (7))){
var inst_37827 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37833_37884 = state_37831__$1;
(statearr_37833_37884[(2)] = inst_37827);

(statearr_37833_37884[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (20))){
var state_37831__$1 = state_37831;
var statearr_37834_37885 = state_37831__$1;
(statearr_37834_37885[(2)] = null);

(statearr_37834_37885[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (1))){
var state_37831__$1 = state_37831;
var statearr_37835_37886 = state_37831__$1;
(statearr_37835_37886[(2)] = null);

(statearr_37835_37886[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (24))){
var inst_37810 = (state_37831[(7)]);
var inst_37819 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_37810);
var state_37831__$1 = state_37831;
var statearr_37836_37887 = state_37831__$1;
(statearr_37836_37887[(2)] = inst_37819);

(statearr_37836_37887[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (4))){
var inst_37762 = (state_37831[(8)]);
var inst_37762__$1 = (state_37831[(2)]);
var inst_37763 = (inst_37762__$1 == null);
var state_37831__$1 = (function (){var statearr_37837 = state_37831;
(statearr_37837[(8)] = inst_37762__$1);

return statearr_37837;
})();
if(cljs.core.truth_(inst_37763)){
var statearr_37838_37888 = state_37831__$1;
(statearr_37838_37888[(1)] = (5));

} else {
var statearr_37839_37889 = state_37831__$1;
(statearr_37839_37889[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (15))){
var inst_37804 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37840_37890 = state_37831__$1;
(statearr_37840_37890[(2)] = inst_37804);

(statearr_37840_37890[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (21))){
var inst_37824 = (state_37831[(2)]);
var state_37831__$1 = (function (){var statearr_37841 = state_37831;
(statearr_37841[(9)] = inst_37824);

return statearr_37841;
})();
var statearr_37842_37891 = state_37831__$1;
(statearr_37842_37891[(2)] = null);

(statearr_37842_37891[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (13))){
var inst_37786 = (state_37831[(10)]);
var inst_37788 = cljs.core.chunked_seq_QMARK_(inst_37786);
var state_37831__$1 = state_37831;
if(inst_37788){
var statearr_37843_37892 = state_37831__$1;
(statearr_37843_37892[(1)] = (16));

} else {
var statearr_37844_37893 = state_37831__$1;
(statearr_37844_37893[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (22))){
var inst_37816 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
if(cljs.core.truth_(inst_37816)){
var statearr_37845_37894 = state_37831__$1;
(statearr_37845_37894[(1)] = (23));

} else {
var statearr_37846_37895 = state_37831__$1;
(statearr_37846_37895[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (6))){
var inst_37810 = (state_37831[(7)]);
var inst_37762 = (state_37831[(8)]);
var inst_37812 = (state_37831[(11)]);
var inst_37810__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_37762) : topic_fn.call(null,inst_37762));
var inst_37811 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_37812__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37811,inst_37810__$1);
var state_37831__$1 = (function (){var statearr_37847 = state_37831;
(statearr_37847[(7)] = inst_37810__$1);

(statearr_37847[(11)] = inst_37812__$1);

return statearr_37847;
})();
if(cljs.core.truth_(inst_37812__$1)){
var statearr_37848_37896 = state_37831__$1;
(statearr_37848_37896[(1)] = (19));

} else {
var statearr_37849_37897 = state_37831__$1;
(statearr_37849_37897[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (25))){
var inst_37821 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37850_37898 = state_37831__$1;
(statearr_37850_37898[(2)] = inst_37821);

(statearr_37850_37898[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (17))){
var inst_37786 = (state_37831[(10)]);
var inst_37795 = cljs.core.first(inst_37786);
var inst_37796 = cljs.core.async.muxch_STAR_(inst_37795);
var inst_37797 = cljs.core.async.close_BANG_(inst_37796);
var inst_37798 = cljs.core.next(inst_37786);
var inst_37772 = inst_37798;
var inst_37773 = null;
var inst_37774 = (0);
var inst_37775 = (0);
var state_37831__$1 = (function (){var statearr_37851 = state_37831;
(statearr_37851[(12)] = inst_37773);

(statearr_37851[(13)] = inst_37772);

(statearr_37851[(14)] = inst_37797);

(statearr_37851[(15)] = inst_37775);

(statearr_37851[(16)] = inst_37774);

return statearr_37851;
})();
var statearr_37852_37899 = state_37831__$1;
(statearr_37852_37899[(2)] = null);

(statearr_37852_37899[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (3))){
var inst_37829 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37831__$1,inst_37829);
} else {
if((state_val_37832 === (12))){
var inst_37806 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37853_37900 = state_37831__$1;
(statearr_37853_37900[(2)] = inst_37806);

(statearr_37853_37900[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (2))){
var state_37831__$1 = state_37831;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37831__$1,(4),ch);
} else {
if((state_val_37832 === (23))){
var state_37831__$1 = state_37831;
var statearr_37854_37901 = state_37831__$1;
(statearr_37854_37901[(2)] = null);

(statearr_37854_37901[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (19))){
var inst_37762 = (state_37831[(8)]);
var inst_37812 = (state_37831[(11)]);
var inst_37814 = cljs.core.async.muxch_STAR_(inst_37812);
var state_37831__$1 = state_37831;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37831__$1,(22),inst_37814,inst_37762);
} else {
if((state_val_37832 === (11))){
var inst_37786 = (state_37831[(10)]);
var inst_37772 = (state_37831[(13)]);
var inst_37786__$1 = cljs.core.seq(inst_37772);
var state_37831__$1 = (function (){var statearr_37855 = state_37831;
(statearr_37855[(10)] = inst_37786__$1);

return statearr_37855;
})();
if(inst_37786__$1){
var statearr_37856_37902 = state_37831__$1;
(statearr_37856_37902[(1)] = (13));

} else {
var statearr_37857_37903 = state_37831__$1;
(statearr_37857_37903[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (9))){
var inst_37808 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37858_37904 = state_37831__$1;
(statearr_37858_37904[(2)] = inst_37808);

(statearr_37858_37904[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (5))){
var inst_37769 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_37770 = cljs.core.vals(inst_37769);
var inst_37771 = cljs.core.seq(inst_37770);
var inst_37772 = inst_37771;
var inst_37773 = null;
var inst_37774 = (0);
var inst_37775 = (0);
var state_37831__$1 = (function (){var statearr_37859 = state_37831;
(statearr_37859[(12)] = inst_37773);

(statearr_37859[(13)] = inst_37772);

(statearr_37859[(15)] = inst_37775);

(statearr_37859[(16)] = inst_37774);

return statearr_37859;
})();
var statearr_37860_37905 = state_37831__$1;
(statearr_37860_37905[(2)] = null);

(statearr_37860_37905[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (14))){
var state_37831__$1 = state_37831;
var statearr_37864_37906 = state_37831__$1;
(statearr_37864_37906[(2)] = null);

(statearr_37864_37906[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (16))){
var inst_37786 = (state_37831[(10)]);
var inst_37790 = cljs.core.chunk_first(inst_37786);
var inst_37791 = cljs.core.chunk_rest(inst_37786);
var inst_37792 = cljs.core.count(inst_37790);
var inst_37772 = inst_37791;
var inst_37773 = inst_37790;
var inst_37774 = inst_37792;
var inst_37775 = (0);
var state_37831__$1 = (function (){var statearr_37865 = state_37831;
(statearr_37865[(12)] = inst_37773);

(statearr_37865[(13)] = inst_37772);

(statearr_37865[(15)] = inst_37775);

(statearr_37865[(16)] = inst_37774);

return statearr_37865;
})();
var statearr_37866_37907 = state_37831__$1;
(statearr_37866_37907[(2)] = null);

(statearr_37866_37907[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (10))){
var inst_37773 = (state_37831[(12)]);
var inst_37772 = (state_37831[(13)]);
var inst_37775 = (state_37831[(15)]);
var inst_37774 = (state_37831[(16)]);
var inst_37780 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37773,inst_37775);
var inst_37781 = cljs.core.async.muxch_STAR_(inst_37780);
var inst_37782 = cljs.core.async.close_BANG_(inst_37781);
var inst_37783 = (inst_37775 + (1));
var tmp37861 = inst_37773;
var tmp37862 = inst_37772;
var tmp37863 = inst_37774;
var inst_37772__$1 = tmp37862;
var inst_37773__$1 = tmp37861;
var inst_37774__$1 = tmp37863;
var inst_37775__$1 = inst_37783;
var state_37831__$1 = (function (){var statearr_37867 = state_37831;
(statearr_37867[(12)] = inst_37773__$1);

(statearr_37867[(13)] = inst_37772__$1);

(statearr_37867[(17)] = inst_37782);

(statearr_37867[(15)] = inst_37775__$1);

(statearr_37867[(16)] = inst_37774__$1);

return statearr_37867;
})();
var statearr_37868_37908 = state_37831__$1;
(statearr_37868_37908[(2)] = null);

(statearr_37868_37908[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (18))){
var inst_37801 = (state_37831[(2)]);
var state_37831__$1 = state_37831;
var statearr_37869_37909 = state_37831__$1;
(statearr_37869_37909[(2)] = inst_37801);

(statearr_37869_37909[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37832 === (8))){
var inst_37775 = (state_37831[(15)]);
var inst_37774 = (state_37831[(16)]);
var inst_37777 = (inst_37775 < inst_37774);
var inst_37778 = inst_37777;
var state_37831__$1 = state_37831;
if(cljs.core.truth_(inst_37778)){
var statearr_37870_37910 = state_37831__$1;
(statearr_37870_37910[(1)] = (10));

} else {
var statearr_37871_37911 = state_37831__$1;
(statearr_37871_37911[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___37883,mults,ensure_mult,p))
;
return ((function (switch__35847__auto__,c__35961__auto___37883,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_37875 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37875[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_37875[(1)] = (1));

return statearr_37875;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_37831){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_37831);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e37876){if((e37876 instanceof Object)){
var ex__35851__auto__ = e37876;
var statearr_37877_37912 = state_37831;
(statearr_37877_37912[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37831);

return cljs.core.cst$kw$recur;
} else {
throw e37876;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__37913 = state_37831;
state_37831 = G__37913;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_37831){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_37831);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___37883,mults,ensure_mult,p))
})();
var state__35963__auto__ = (function (){var statearr_37878 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_37878[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___37883);

return statearr_37878;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___37883,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args37914 = [];
var len__5740__auto___37917 = arguments.length;
var i__5741__auto___37918 = (0);
while(true){
if((i__5741__auto___37918 < len__5740__auto___37917)){
args37914.push((arguments[i__5741__auto___37918]));

var G__37919 = (i__5741__auto___37918 + (1));
i__5741__auto___37918 = G__37919;
continue;
} else {
}
break;
}

var G__37916 = args37914.length;
switch (G__37916) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37914.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args37921 = [];
var len__5740__auto___37924 = arguments.length;
var i__5741__auto___37925 = (0);
while(true){
if((i__5741__auto___37925 < len__5740__auto___37924)){
args37921.push((arguments[i__5741__auto___37925]));

var G__37926 = (i__5741__auto___37925 + (1));
i__5741__auto___37925 = G__37926;
continue;
} else {
}
break;
}

var G__37923 = args37921.length;
switch (G__37923) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37921.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args37928 = [];
var len__5740__auto___37999 = arguments.length;
var i__5741__auto___38000 = (0);
while(true){
if((i__5741__auto___38000 < len__5740__auto___37999)){
args37928.push((arguments[i__5741__auto___38000]));

var G__38001 = (i__5741__auto___38000 + (1));
i__5741__auto___38000 = G__38001;
continue;
} else {
}
break;
}

var G__37930 = args37928.length;
switch (G__37930) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37928.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__35961__auto___38003 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_37969){
var state_val_37970 = (state_37969[(1)]);
if((state_val_37970 === (7))){
var state_37969__$1 = state_37969;
var statearr_37971_38004 = state_37969__$1;
(statearr_37971_38004[(2)] = null);

(statearr_37971_38004[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (1))){
var state_37969__$1 = state_37969;
var statearr_37972_38005 = state_37969__$1;
(statearr_37972_38005[(2)] = null);

(statearr_37972_38005[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (4))){
var inst_37933 = (state_37969[(7)]);
var inst_37935 = (inst_37933 < cnt);
var state_37969__$1 = state_37969;
if(cljs.core.truth_(inst_37935)){
var statearr_37973_38006 = state_37969__$1;
(statearr_37973_38006[(1)] = (6));

} else {
var statearr_37974_38007 = state_37969__$1;
(statearr_37974_38007[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (15))){
var inst_37965 = (state_37969[(2)]);
var state_37969__$1 = state_37969;
var statearr_37975_38008 = state_37969__$1;
(statearr_37975_38008[(2)] = inst_37965);

(statearr_37975_38008[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (13))){
var inst_37958 = cljs.core.async.close_BANG_(out);
var state_37969__$1 = state_37969;
var statearr_37976_38009 = state_37969__$1;
(statearr_37976_38009[(2)] = inst_37958);

(statearr_37976_38009[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (6))){
var state_37969__$1 = state_37969;
var statearr_37977_38010 = state_37969__$1;
(statearr_37977_38010[(2)] = null);

(statearr_37977_38010[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (3))){
var inst_37967 = (state_37969[(2)]);
var state_37969__$1 = state_37969;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37969__$1,inst_37967);
} else {
if((state_val_37970 === (12))){
var inst_37955 = (state_37969[(8)]);
var inst_37955__$1 = (state_37969[(2)]);
var inst_37956 = cljs.core.some(cljs.core.nil_QMARK_,inst_37955__$1);
var state_37969__$1 = (function (){var statearr_37978 = state_37969;
(statearr_37978[(8)] = inst_37955__$1);

return statearr_37978;
})();
if(cljs.core.truth_(inst_37956)){
var statearr_37979_38011 = state_37969__$1;
(statearr_37979_38011[(1)] = (13));

} else {
var statearr_37980_38012 = state_37969__$1;
(statearr_37980_38012[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (2))){
var inst_37932 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cnt) : cljs.core.reset_BANG_.call(null,dctr,cnt));
var inst_37933 = (0);
var state_37969__$1 = (function (){var statearr_37981 = state_37969;
(statearr_37981[(7)] = inst_37933);

(statearr_37981[(9)] = inst_37932);

return statearr_37981;
})();
var statearr_37982_38013 = state_37969__$1;
(statearr_37982_38013[(2)] = null);

(statearr_37982_38013[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (11))){
var inst_37933 = (state_37969[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_37969,(10),Object,null,(9));
var inst_37942 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_37933) : chs__$1.call(null,inst_37933));
var inst_37943 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_37933) : done.call(null,inst_37933));
var inst_37944 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_37942,inst_37943);
var state_37969__$1 = state_37969;
var statearr_37983_38014 = state_37969__$1;
(statearr_37983_38014[(2)] = inst_37944);


cljs.core.async.impl.ioc_helpers.process_exception(state_37969__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (9))){
var inst_37933 = (state_37969[(7)]);
var inst_37946 = (state_37969[(2)]);
var inst_37947 = (inst_37933 + (1));
var inst_37933__$1 = inst_37947;
var state_37969__$1 = (function (){var statearr_37984 = state_37969;
(statearr_37984[(7)] = inst_37933__$1);

(statearr_37984[(10)] = inst_37946);

return statearr_37984;
})();
var statearr_37985_38015 = state_37969__$1;
(statearr_37985_38015[(2)] = null);

(statearr_37985_38015[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (5))){
var inst_37953 = (state_37969[(2)]);
var state_37969__$1 = (function (){var statearr_37986 = state_37969;
(statearr_37986[(11)] = inst_37953);

return statearr_37986;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37969__$1,(12),dchan);
} else {
if((state_val_37970 === (14))){
var inst_37955 = (state_37969[(8)]);
var inst_37960 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_37955);
var state_37969__$1 = state_37969;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37969__$1,(16),out,inst_37960);
} else {
if((state_val_37970 === (16))){
var inst_37962 = (state_37969[(2)]);
var state_37969__$1 = (function (){var statearr_37987 = state_37969;
(statearr_37987[(12)] = inst_37962);

return statearr_37987;
})();
var statearr_37988_38016 = state_37969__$1;
(statearr_37988_38016[(2)] = null);

(statearr_37988_38016[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (10))){
var inst_37937 = (state_37969[(2)]);
var inst_37938 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_37969__$1 = (function (){var statearr_37989 = state_37969;
(statearr_37989[(13)] = inst_37937);

return statearr_37989;
})();
var statearr_37990_38017 = state_37969__$1;
(statearr_37990_38017[(2)] = inst_37938);


cljs.core.async.impl.ioc_helpers.process_exception(state_37969__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_37970 === (8))){
var inst_37951 = (state_37969[(2)]);
var state_37969__$1 = state_37969;
var statearr_37991_38018 = state_37969__$1;
(statearr_37991_38018[(2)] = inst_37951);

(statearr_37991_38018[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__35847__auto__,c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_37995 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37995[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_37995[(1)] = (1));

return statearr_37995;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_37969){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_37969);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e37996){if((e37996 instanceof Object)){
var ex__35851__auto__ = e37996;
var statearr_37997_38019 = state_37969;
(statearr_37997_38019[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37969);

return cljs.core.cst$kw$recur;
} else {
throw e37996;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38020 = state_37969;
state_37969 = G__38020;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_37969){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_37969);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__35963__auto__ = (function (){var statearr_37998 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_37998[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38003);

return statearr_37998;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38003,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args38022 = [];
var len__5740__auto___38078 = arguments.length;
var i__5741__auto___38079 = (0);
while(true){
if((i__5741__auto___38079 < len__5740__auto___38078)){
args38022.push((arguments[i__5741__auto___38079]));

var G__38080 = (i__5741__auto___38079 + (1));
i__5741__auto___38079 = G__38080;
continue;
} else {
}
break;
}

var G__38024 = args38022.length;
switch (G__38024) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38022.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38082 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38082,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38082,out){
return (function (state_38054){
var state_val_38055 = (state_38054[(1)]);
if((state_val_38055 === (7))){
var inst_38033 = (state_38054[(7)]);
var inst_38034 = (state_38054[(8)]);
var inst_38033__$1 = (state_38054[(2)]);
var inst_38034__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_38033__$1,(0),null);
var inst_38035 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_38033__$1,(1),null);
var inst_38036 = (inst_38034__$1 == null);
var state_38054__$1 = (function (){var statearr_38056 = state_38054;
(statearr_38056[(7)] = inst_38033__$1);

(statearr_38056[(8)] = inst_38034__$1);

(statearr_38056[(9)] = inst_38035);

return statearr_38056;
})();
if(cljs.core.truth_(inst_38036)){
var statearr_38057_38083 = state_38054__$1;
(statearr_38057_38083[(1)] = (8));

} else {
var statearr_38058_38084 = state_38054__$1;
(statearr_38058_38084[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (1))){
var inst_38025 = cljs.core.vec(chs);
var inst_38026 = inst_38025;
var state_38054__$1 = (function (){var statearr_38059 = state_38054;
(statearr_38059[(10)] = inst_38026);

return statearr_38059;
})();
var statearr_38060_38085 = state_38054__$1;
(statearr_38060_38085[(2)] = null);

(statearr_38060_38085[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (4))){
var inst_38026 = (state_38054[(10)]);
var state_38054__$1 = state_38054;
return cljs.core.async.ioc_alts_BANG_(state_38054__$1,(7),inst_38026);
} else {
if((state_val_38055 === (6))){
var inst_38050 = (state_38054[(2)]);
var state_38054__$1 = state_38054;
var statearr_38061_38086 = state_38054__$1;
(statearr_38061_38086[(2)] = inst_38050);

(statearr_38061_38086[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (3))){
var inst_38052 = (state_38054[(2)]);
var state_38054__$1 = state_38054;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38054__$1,inst_38052);
} else {
if((state_val_38055 === (2))){
var inst_38026 = (state_38054[(10)]);
var inst_38028 = cljs.core.count(inst_38026);
var inst_38029 = (inst_38028 > (0));
var state_38054__$1 = state_38054;
if(cljs.core.truth_(inst_38029)){
var statearr_38063_38087 = state_38054__$1;
(statearr_38063_38087[(1)] = (4));

} else {
var statearr_38064_38088 = state_38054__$1;
(statearr_38064_38088[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (11))){
var inst_38026 = (state_38054[(10)]);
var inst_38043 = (state_38054[(2)]);
var tmp38062 = inst_38026;
var inst_38026__$1 = tmp38062;
var state_38054__$1 = (function (){var statearr_38065 = state_38054;
(statearr_38065[(10)] = inst_38026__$1);

(statearr_38065[(11)] = inst_38043);

return statearr_38065;
})();
var statearr_38066_38089 = state_38054__$1;
(statearr_38066_38089[(2)] = null);

(statearr_38066_38089[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (9))){
var inst_38034 = (state_38054[(8)]);
var state_38054__$1 = state_38054;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38054__$1,(11),out,inst_38034);
} else {
if((state_val_38055 === (5))){
var inst_38048 = cljs.core.async.close_BANG_(out);
var state_38054__$1 = state_38054;
var statearr_38067_38090 = state_38054__$1;
(statearr_38067_38090[(2)] = inst_38048);

(statearr_38067_38090[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (10))){
var inst_38046 = (state_38054[(2)]);
var state_38054__$1 = state_38054;
var statearr_38068_38091 = state_38054__$1;
(statearr_38068_38091[(2)] = inst_38046);

(statearr_38068_38091[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38055 === (8))){
var inst_38026 = (state_38054[(10)]);
var inst_38033 = (state_38054[(7)]);
var inst_38034 = (state_38054[(8)]);
var inst_38035 = (state_38054[(9)]);
var inst_38038 = (function (){var cs = inst_38026;
var vec__38031 = inst_38033;
var v = inst_38034;
var c = inst_38035;
return ((function (cs,vec__38031,v,c,inst_38026,inst_38033,inst_38034,inst_38035,state_val_38055,c__35961__auto___38082,out){
return (function (p1__38021_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__38021_SHARP_);
});
;})(cs,vec__38031,v,c,inst_38026,inst_38033,inst_38034,inst_38035,state_val_38055,c__35961__auto___38082,out))
})();
var inst_38039 = cljs.core.filterv(inst_38038,inst_38026);
var inst_38026__$1 = inst_38039;
var state_38054__$1 = (function (){var statearr_38069 = state_38054;
(statearr_38069[(10)] = inst_38026__$1);

return statearr_38069;
})();
var statearr_38070_38092 = state_38054__$1;
(statearr_38070_38092[(2)] = null);

(statearr_38070_38092[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38082,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38082,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38074 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38074[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38074[(1)] = (1));

return statearr_38074;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38054){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38054);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38075){if((e38075 instanceof Object)){
var ex__35851__auto__ = e38075;
var statearr_38076_38093 = state_38054;
(statearr_38076_38093[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38054);

return cljs.core.cst$kw$recur;
} else {
throw e38075;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38094 = state_38054;
state_38054 = G__38094;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38054){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38054);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38082,out))
})();
var state__35963__auto__ = (function (){var statearr_38077 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38077[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38082);

return statearr_38077;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38082,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args38095 = [];
var len__5740__auto___38144 = arguments.length;
var i__5741__auto___38145 = (0);
while(true){
if((i__5741__auto___38145 < len__5740__auto___38144)){
args38095.push((arguments[i__5741__auto___38145]));

var G__38146 = (i__5741__auto___38145 + (1));
i__5741__auto___38145 = G__38146;
continue;
} else {
}
break;
}

var G__38097 = args38095.length;
switch (G__38097) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38095.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38148 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38148,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38148,out){
return (function (state_38121){
var state_val_38122 = (state_38121[(1)]);
if((state_val_38122 === (7))){
var inst_38103 = (state_38121[(7)]);
var inst_38103__$1 = (state_38121[(2)]);
var inst_38104 = (inst_38103__$1 == null);
var inst_38105 = cljs.core.not(inst_38104);
var state_38121__$1 = (function (){var statearr_38123 = state_38121;
(statearr_38123[(7)] = inst_38103__$1);

return statearr_38123;
})();
if(inst_38105){
var statearr_38124_38149 = state_38121__$1;
(statearr_38124_38149[(1)] = (8));

} else {
var statearr_38125_38150 = state_38121__$1;
(statearr_38125_38150[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (1))){
var inst_38098 = (0);
var state_38121__$1 = (function (){var statearr_38126 = state_38121;
(statearr_38126[(8)] = inst_38098);

return statearr_38126;
})();
var statearr_38127_38151 = state_38121__$1;
(statearr_38127_38151[(2)] = null);

(statearr_38127_38151[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (4))){
var state_38121__$1 = state_38121;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38121__$1,(7),ch);
} else {
if((state_val_38122 === (6))){
var inst_38116 = (state_38121[(2)]);
var state_38121__$1 = state_38121;
var statearr_38128_38152 = state_38121__$1;
(statearr_38128_38152[(2)] = inst_38116);

(statearr_38128_38152[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (3))){
var inst_38118 = (state_38121[(2)]);
var inst_38119 = cljs.core.async.close_BANG_(out);
var state_38121__$1 = (function (){var statearr_38129 = state_38121;
(statearr_38129[(9)] = inst_38118);

return statearr_38129;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_38121__$1,inst_38119);
} else {
if((state_val_38122 === (2))){
var inst_38098 = (state_38121[(8)]);
var inst_38100 = (inst_38098 < n);
var state_38121__$1 = state_38121;
if(cljs.core.truth_(inst_38100)){
var statearr_38130_38153 = state_38121__$1;
(statearr_38130_38153[(1)] = (4));

} else {
var statearr_38131_38154 = state_38121__$1;
(statearr_38131_38154[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (11))){
var inst_38098 = (state_38121[(8)]);
var inst_38108 = (state_38121[(2)]);
var inst_38109 = (inst_38098 + (1));
var inst_38098__$1 = inst_38109;
var state_38121__$1 = (function (){var statearr_38132 = state_38121;
(statearr_38132[(10)] = inst_38108);

(statearr_38132[(8)] = inst_38098__$1);

return statearr_38132;
})();
var statearr_38133_38155 = state_38121__$1;
(statearr_38133_38155[(2)] = null);

(statearr_38133_38155[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (9))){
var state_38121__$1 = state_38121;
var statearr_38134_38156 = state_38121__$1;
(statearr_38134_38156[(2)] = null);

(statearr_38134_38156[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (5))){
var state_38121__$1 = state_38121;
var statearr_38135_38157 = state_38121__$1;
(statearr_38135_38157[(2)] = null);

(statearr_38135_38157[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (10))){
var inst_38113 = (state_38121[(2)]);
var state_38121__$1 = state_38121;
var statearr_38136_38158 = state_38121__$1;
(statearr_38136_38158[(2)] = inst_38113);

(statearr_38136_38158[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38122 === (8))){
var inst_38103 = (state_38121[(7)]);
var state_38121__$1 = state_38121;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38121__$1,(11),out,inst_38103);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38148,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38148,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38140 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_38140[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38140[(1)] = (1));

return statearr_38140;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38121){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38121);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38141){if((e38141 instanceof Object)){
var ex__35851__auto__ = e38141;
var statearr_38142_38159 = state_38121;
(statearr_38142_38159[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38121);

return cljs.core.cst$kw$recur;
} else {
throw e38141;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38160 = state_38121;
state_38121 = G__38160;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38121){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38121);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38148,out))
})();
var state__35963__auto__ = (function (){var statearr_38143 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38143[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38148);

return statearr_38143;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38148,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async38170 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38170 = (function (map_LT_,f,ch,meta38171){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta38171 = meta38171;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38172,meta38171__$1){
var self__ = this;
var _38172__$1 = this;
return (new cljs.core.async.t_cljs$core$async38170(self__.map_LT_,self__.f,self__.ch,meta38171__$1));
});

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38172){
var self__ = this;
var _38172__$1 = this;
return self__.meta38171;
});

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async38173 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38173 = (function (map_LT_,f,ch,meta38171,_,fn1,meta38174){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta38171 = meta38171;
this._ = _;
this.fn1 = fn1;
this.meta38174 = meta38174;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_38175,meta38174__$1){
var self__ = this;
var _38175__$1 = this;
return (new cljs.core.async.t_cljs$core$async38173(self__.map_LT_,self__.f,self__.ch,self__.meta38171,self__._,self__.fn1,meta38174__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_38175){
var self__ = this;
var _38175__$1 = this;
return self__.meta38174;
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__38161_SHARP_){
var G__38176 = (((p1__38161_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__38161_SHARP_) : self__.f.call(null,p1__38161_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__38176) : f1.call(null,G__38176));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38171,cljs.core.with_meta(cljs.core.cst$sym$_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$tag,cljs.core.cst$sym$cljs$core$async_SLASH_t_cljs$core$async38170], null)),cljs.core.cst$sym$fn1,cljs.core.cst$sym$meta38174], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async38173.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38173.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38173";

cljs.core.async.t_cljs$core$async38173.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38173");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async38173 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async38173(map_LT___$1,f__$1,ch__$1,meta38171__$1,___$2,fn1__$1,meta38174){
return (new cljs.core.async.t_cljs$core$async38173(map_LT___$1,f__$1,ch__$1,meta38171__$1,___$2,fn1__$1,meta38174));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async38173(self__.map_LT_,self__.f,self__.ch,self__.meta38171,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4670__auto__ = ret;
if(cljs.core.truth_(and__4670__auto__)){
return !(((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret)) == null));
} else {
return and__4670__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__38177 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__38177) : self__.f.call(null,G__38177));
})());
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38170.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async38170.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38171], null);
});

cljs.core.async.t_cljs$core$async38170.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38170.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38170";

cljs.core.async.t_cljs$core$async38170.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38170");
});

cljs.core.async.__GT_t_cljs$core$async38170 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async38170(map_LT___$1,f__$1,ch__$1,meta38171){
return (new cljs.core.async.t_cljs$core$async38170(map_LT___$1,f__$1,ch__$1,meta38171));
});

}

return (new cljs.core.async.t_cljs$core$async38170(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async38181 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38181 = (function (map_GT_,f,ch,meta38182){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta38182 = meta38182;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38183,meta38182__$1){
var self__ = this;
var _38183__$1 = this;
return (new cljs.core.async.t_cljs$core$async38181(self__.map_GT_,self__.f,self__.ch,meta38182__$1));
});

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38183){
var self__ = this;
var _38183__$1 = this;
return self__.meta38182;
});

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38181.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
});

cljs.core.async.t_cljs$core$async38181.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38182], null);
});

cljs.core.async.t_cljs$core$async38181.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38181.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38181";

cljs.core.async.t_cljs$core$async38181.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38181");
});

cljs.core.async.__GT_t_cljs$core$async38181 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async38181(map_GT___$1,f__$1,ch__$1,meta38182){
return (new cljs.core.async.t_cljs$core$async38181(map_GT___$1,f__$1,ch__$1,meta38182));
});

}

return (new cljs.core.async.t_cljs$core$async38181(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async38187 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38187 = (function (filter_GT_,p,ch,meta38188){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta38188 = meta38188;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38189,meta38188__$1){
var self__ = this;
var _38189__$1 = this;
return (new cljs.core.async.t_cljs$core$async38187(self__.filter_GT_,self__.p,self__.ch,meta38188__$1));
});

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38189){
var self__ = this;
var _38189__$1 = this;
return self__.meta38188;
});

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38187.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t_cljs$core$async38187.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$filter_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$p,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$p,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38188], null);
});

cljs.core.async.t_cljs$core$async38187.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38187.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38187";

cljs.core.async.t_cljs$core$async38187.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38187");
});

cljs.core.async.__GT_t_cljs$core$async38187 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async38187(filter_GT___$1,p__$1,ch__$1,meta38188){
return (new cljs.core.async.t_cljs$core$async38187(filter_GT___$1,p__$1,ch__$1,meta38188));
});

}

return (new cljs.core.async.t_cljs$core$async38187(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args38190 = [];
var len__5740__auto___38234 = arguments.length;
var i__5741__auto___38235 = (0);
while(true){
if((i__5741__auto___38235 < len__5740__auto___38234)){
args38190.push((arguments[i__5741__auto___38235]));

var G__38236 = (i__5741__auto___38235 + (1));
i__5741__auto___38235 = G__38236;
continue;
} else {
}
break;
}

var G__38192 = args38190.length;
switch (G__38192) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38190.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38238 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38238,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38238,out){
return (function (state_38213){
var state_val_38214 = (state_38213[(1)]);
if((state_val_38214 === (7))){
var inst_38209 = (state_38213[(2)]);
var state_38213__$1 = state_38213;
var statearr_38215_38239 = state_38213__$1;
(statearr_38215_38239[(2)] = inst_38209);

(statearr_38215_38239[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (1))){
var state_38213__$1 = state_38213;
var statearr_38216_38240 = state_38213__$1;
(statearr_38216_38240[(2)] = null);

(statearr_38216_38240[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (4))){
var inst_38195 = (state_38213[(7)]);
var inst_38195__$1 = (state_38213[(2)]);
var inst_38196 = (inst_38195__$1 == null);
var state_38213__$1 = (function (){var statearr_38217 = state_38213;
(statearr_38217[(7)] = inst_38195__$1);

return statearr_38217;
})();
if(cljs.core.truth_(inst_38196)){
var statearr_38218_38241 = state_38213__$1;
(statearr_38218_38241[(1)] = (5));

} else {
var statearr_38219_38242 = state_38213__$1;
(statearr_38219_38242[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (6))){
var inst_38195 = (state_38213[(7)]);
var inst_38200 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_38195) : p.call(null,inst_38195));
var state_38213__$1 = state_38213;
if(cljs.core.truth_(inst_38200)){
var statearr_38220_38243 = state_38213__$1;
(statearr_38220_38243[(1)] = (8));

} else {
var statearr_38221_38244 = state_38213__$1;
(statearr_38221_38244[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (3))){
var inst_38211 = (state_38213[(2)]);
var state_38213__$1 = state_38213;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38213__$1,inst_38211);
} else {
if((state_val_38214 === (2))){
var state_38213__$1 = state_38213;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38213__$1,(4),ch);
} else {
if((state_val_38214 === (11))){
var inst_38203 = (state_38213[(2)]);
var state_38213__$1 = state_38213;
var statearr_38222_38245 = state_38213__$1;
(statearr_38222_38245[(2)] = inst_38203);

(statearr_38222_38245[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (9))){
var state_38213__$1 = state_38213;
var statearr_38223_38246 = state_38213__$1;
(statearr_38223_38246[(2)] = null);

(statearr_38223_38246[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (5))){
var inst_38198 = cljs.core.async.close_BANG_(out);
var state_38213__$1 = state_38213;
var statearr_38224_38247 = state_38213__$1;
(statearr_38224_38247[(2)] = inst_38198);

(statearr_38224_38247[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (10))){
var inst_38206 = (state_38213[(2)]);
var state_38213__$1 = (function (){var statearr_38225 = state_38213;
(statearr_38225[(8)] = inst_38206);

return statearr_38225;
})();
var statearr_38226_38248 = state_38213__$1;
(statearr_38226_38248[(2)] = null);

(statearr_38226_38248[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38214 === (8))){
var inst_38195 = (state_38213[(7)]);
var state_38213__$1 = state_38213;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38213__$1,(11),out,inst_38195);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38238,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38238,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38230 = [null,null,null,null,null,null,null,null,null];
(statearr_38230[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38230[(1)] = (1));

return statearr_38230;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38213){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38213);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38231){if((e38231 instanceof Object)){
var ex__35851__auto__ = e38231;
var statearr_38232_38249 = state_38213;
(statearr_38232_38249[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38213);

return cljs.core.cst$kw$recur;
} else {
throw e38231;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38250 = state_38213;
state_38213 = G__38250;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38213){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38213);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38238,out))
})();
var state__35963__auto__ = (function (){var statearr_38233 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38233[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38238);

return statearr_38233;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38238,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args38251 = [];
var len__5740__auto___38254 = arguments.length;
var i__5741__auto___38255 = (0);
while(true){
if((i__5741__auto___38255 < len__5740__auto___38254)){
args38251.push((arguments[i__5741__auto___38255]));

var G__38256 = (i__5741__auto___38255 + (1));
i__5741__auto___38255 = G__38256;
continue;
} else {
}
break;
}

var G__38253 = args38251.length;
switch (G__38253) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38251.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__35961__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto__){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto__){
return (function (state_38423){
var state_val_38424 = (state_38423[(1)]);
if((state_val_38424 === (7))){
var inst_38419 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
var statearr_38425_38466 = state_38423__$1;
(statearr_38425_38466[(2)] = inst_38419);

(statearr_38425_38466[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (20))){
var inst_38389 = (state_38423[(7)]);
var inst_38400 = (state_38423[(2)]);
var inst_38401 = cljs.core.next(inst_38389);
var inst_38375 = inst_38401;
var inst_38376 = null;
var inst_38377 = (0);
var inst_38378 = (0);
var state_38423__$1 = (function (){var statearr_38426 = state_38423;
(statearr_38426[(8)] = inst_38400);

(statearr_38426[(9)] = inst_38378);

(statearr_38426[(10)] = inst_38375);

(statearr_38426[(11)] = inst_38377);

(statearr_38426[(12)] = inst_38376);

return statearr_38426;
})();
var statearr_38427_38467 = state_38423__$1;
(statearr_38427_38467[(2)] = null);

(statearr_38427_38467[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (1))){
var state_38423__$1 = state_38423;
var statearr_38428_38468 = state_38423__$1;
(statearr_38428_38468[(2)] = null);

(statearr_38428_38468[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (4))){
var inst_38364 = (state_38423[(13)]);
var inst_38364__$1 = (state_38423[(2)]);
var inst_38365 = (inst_38364__$1 == null);
var state_38423__$1 = (function (){var statearr_38429 = state_38423;
(statearr_38429[(13)] = inst_38364__$1);

return statearr_38429;
})();
if(cljs.core.truth_(inst_38365)){
var statearr_38430_38469 = state_38423__$1;
(statearr_38430_38469[(1)] = (5));

} else {
var statearr_38431_38470 = state_38423__$1;
(statearr_38431_38470[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (15))){
var state_38423__$1 = state_38423;
var statearr_38435_38471 = state_38423__$1;
(statearr_38435_38471[(2)] = null);

(statearr_38435_38471[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (21))){
var state_38423__$1 = state_38423;
var statearr_38436_38472 = state_38423__$1;
(statearr_38436_38472[(2)] = null);

(statearr_38436_38472[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (13))){
var inst_38378 = (state_38423[(9)]);
var inst_38375 = (state_38423[(10)]);
var inst_38377 = (state_38423[(11)]);
var inst_38376 = (state_38423[(12)]);
var inst_38385 = (state_38423[(2)]);
var inst_38386 = (inst_38378 + (1));
var tmp38432 = inst_38375;
var tmp38433 = inst_38377;
var tmp38434 = inst_38376;
var inst_38375__$1 = tmp38432;
var inst_38376__$1 = tmp38434;
var inst_38377__$1 = tmp38433;
var inst_38378__$1 = inst_38386;
var state_38423__$1 = (function (){var statearr_38437 = state_38423;
(statearr_38437[(9)] = inst_38378__$1);

(statearr_38437[(10)] = inst_38375__$1);

(statearr_38437[(14)] = inst_38385);

(statearr_38437[(11)] = inst_38377__$1);

(statearr_38437[(12)] = inst_38376__$1);

return statearr_38437;
})();
var statearr_38438_38473 = state_38423__$1;
(statearr_38438_38473[(2)] = null);

(statearr_38438_38473[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (22))){
var state_38423__$1 = state_38423;
var statearr_38439_38474 = state_38423__$1;
(statearr_38439_38474[(2)] = null);

(statearr_38439_38474[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (6))){
var inst_38364 = (state_38423[(13)]);
var inst_38373 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_38364) : f.call(null,inst_38364));
var inst_38374 = cljs.core.seq(inst_38373);
var inst_38375 = inst_38374;
var inst_38376 = null;
var inst_38377 = (0);
var inst_38378 = (0);
var state_38423__$1 = (function (){var statearr_38440 = state_38423;
(statearr_38440[(9)] = inst_38378);

(statearr_38440[(10)] = inst_38375);

(statearr_38440[(11)] = inst_38377);

(statearr_38440[(12)] = inst_38376);

return statearr_38440;
})();
var statearr_38441_38475 = state_38423__$1;
(statearr_38441_38475[(2)] = null);

(statearr_38441_38475[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (17))){
var inst_38389 = (state_38423[(7)]);
var inst_38393 = cljs.core.chunk_first(inst_38389);
var inst_38394 = cljs.core.chunk_rest(inst_38389);
var inst_38395 = cljs.core.count(inst_38393);
var inst_38375 = inst_38394;
var inst_38376 = inst_38393;
var inst_38377 = inst_38395;
var inst_38378 = (0);
var state_38423__$1 = (function (){var statearr_38442 = state_38423;
(statearr_38442[(9)] = inst_38378);

(statearr_38442[(10)] = inst_38375);

(statearr_38442[(11)] = inst_38377);

(statearr_38442[(12)] = inst_38376);

return statearr_38442;
})();
var statearr_38443_38476 = state_38423__$1;
(statearr_38443_38476[(2)] = null);

(statearr_38443_38476[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (3))){
var inst_38421 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38423__$1,inst_38421);
} else {
if((state_val_38424 === (12))){
var inst_38409 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
var statearr_38444_38477 = state_38423__$1;
(statearr_38444_38477[(2)] = inst_38409);

(statearr_38444_38477[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (2))){
var state_38423__$1 = state_38423;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38423__$1,(4),in$);
} else {
if((state_val_38424 === (23))){
var inst_38417 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
var statearr_38445_38478 = state_38423__$1;
(statearr_38445_38478[(2)] = inst_38417);

(statearr_38445_38478[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (19))){
var inst_38404 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
var statearr_38446_38479 = state_38423__$1;
(statearr_38446_38479[(2)] = inst_38404);

(statearr_38446_38479[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (11))){
var inst_38389 = (state_38423[(7)]);
var inst_38375 = (state_38423[(10)]);
var inst_38389__$1 = cljs.core.seq(inst_38375);
var state_38423__$1 = (function (){var statearr_38447 = state_38423;
(statearr_38447[(7)] = inst_38389__$1);

return statearr_38447;
})();
if(inst_38389__$1){
var statearr_38448_38480 = state_38423__$1;
(statearr_38448_38480[(1)] = (14));

} else {
var statearr_38449_38481 = state_38423__$1;
(statearr_38449_38481[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (9))){
var inst_38411 = (state_38423[(2)]);
var inst_38412 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_38423__$1 = (function (){var statearr_38450 = state_38423;
(statearr_38450[(15)] = inst_38411);

return statearr_38450;
})();
if(cljs.core.truth_(inst_38412)){
var statearr_38451_38482 = state_38423__$1;
(statearr_38451_38482[(1)] = (21));

} else {
var statearr_38452_38483 = state_38423__$1;
(statearr_38452_38483[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (5))){
var inst_38367 = cljs.core.async.close_BANG_(out);
var state_38423__$1 = state_38423;
var statearr_38453_38484 = state_38423__$1;
(statearr_38453_38484[(2)] = inst_38367);

(statearr_38453_38484[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (14))){
var inst_38389 = (state_38423[(7)]);
var inst_38391 = cljs.core.chunked_seq_QMARK_(inst_38389);
var state_38423__$1 = state_38423;
if(inst_38391){
var statearr_38454_38485 = state_38423__$1;
(statearr_38454_38485[(1)] = (17));

} else {
var statearr_38455_38486 = state_38423__$1;
(statearr_38455_38486[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (16))){
var inst_38407 = (state_38423[(2)]);
var state_38423__$1 = state_38423;
var statearr_38456_38487 = state_38423__$1;
(statearr_38456_38487[(2)] = inst_38407);

(statearr_38456_38487[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38424 === (10))){
var inst_38378 = (state_38423[(9)]);
var inst_38376 = (state_38423[(12)]);
var inst_38383 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_38376,inst_38378);
var state_38423__$1 = state_38423;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38423__$1,(13),out,inst_38383);
} else {
if((state_val_38424 === (18))){
var inst_38389 = (state_38423[(7)]);
var inst_38398 = cljs.core.first(inst_38389);
var state_38423__$1 = state_38423;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38423__$1,(20),out,inst_38398);
} else {
if((state_val_38424 === (8))){
var inst_38378 = (state_38423[(9)]);
var inst_38377 = (state_38423[(11)]);
var inst_38380 = (inst_38378 < inst_38377);
var inst_38381 = inst_38380;
var state_38423__$1 = state_38423;
if(cljs.core.truth_(inst_38381)){
var statearr_38457_38488 = state_38423__$1;
(statearr_38457_38488[(1)] = (10));

} else {
var statearr_38458_38489 = state_38423__$1;
(statearr_38458_38489[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto__))
;
return ((function (switch__35847__auto__,c__35961__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____0 = (function (){
var statearr_38462 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38462[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__);

(statearr_38462[(1)] = (1));

return statearr_38462;
});
var cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____1 = (function (state_38423){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38423);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38463){if((e38463 instanceof Object)){
var ex__35851__auto__ = e38463;
var statearr_38464_38490 = state_38423;
(statearr_38464_38490[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38423);

return cljs.core.cst$kw$recur;
} else {
throw e38463;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38491 = state_38423;
state_38423 = G__38491;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__ = function(state_38423){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____1.call(this,state_38423);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__35848__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto__))
})();
var state__35963__auto__ = (function (){var statearr_38465 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38465[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto__);

return statearr_38465;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto__))
);

return c__35961__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args38492 = [];
var len__5740__auto___38495 = arguments.length;
var i__5741__auto___38496 = (0);
while(true){
if((i__5741__auto___38496 < len__5740__auto___38495)){
args38492.push((arguments[i__5741__auto___38496]));

var G__38497 = (i__5741__auto___38496 + (1));
i__5741__auto___38496 = G__38497;
continue;
} else {
}
break;
}

var G__38494 = args38492.length;
switch (G__38494) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38492.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args38499 = [];
var len__5740__auto___38502 = arguments.length;
var i__5741__auto___38503 = (0);
while(true){
if((i__5741__auto___38503 < len__5740__auto___38502)){
args38499.push((arguments[i__5741__auto___38503]));

var G__38504 = (i__5741__auto___38503 + (1));
i__5741__auto___38503 = G__38504;
continue;
} else {
}
break;
}

var G__38501 = args38499.length;
switch (G__38501) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38499.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args38506 = [];
var len__5740__auto___38557 = arguments.length;
var i__5741__auto___38558 = (0);
while(true){
if((i__5741__auto___38558 < len__5740__auto___38557)){
args38506.push((arguments[i__5741__auto___38558]));

var G__38559 = (i__5741__auto___38558 + (1));
i__5741__auto___38558 = G__38559;
continue;
} else {
}
break;
}

var G__38508 = args38506.length;
switch (G__38508) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38506.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38561 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38561,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38561,out){
return (function (state_38532){
var state_val_38533 = (state_38532[(1)]);
if((state_val_38533 === (7))){
var inst_38527 = (state_38532[(2)]);
var state_38532__$1 = state_38532;
var statearr_38534_38562 = state_38532__$1;
(statearr_38534_38562[(2)] = inst_38527);

(statearr_38534_38562[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (1))){
var inst_38509 = null;
var state_38532__$1 = (function (){var statearr_38535 = state_38532;
(statearr_38535[(7)] = inst_38509);

return statearr_38535;
})();
var statearr_38536_38563 = state_38532__$1;
(statearr_38536_38563[(2)] = null);

(statearr_38536_38563[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (4))){
var inst_38512 = (state_38532[(8)]);
var inst_38512__$1 = (state_38532[(2)]);
var inst_38513 = (inst_38512__$1 == null);
var inst_38514 = cljs.core.not(inst_38513);
var state_38532__$1 = (function (){var statearr_38537 = state_38532;
(statearr_38537[(8)] = inst_38512__$1);

return statearr_38537;
})();
if(inst_38514){
var statearr_38538_38564 = state_38532__$1;
(statearr_38538_38564[(1)] = (5));

} else {
var statearr_38539_38565 = state_38532__$1;
(statearr_38539_38565[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (6))){
var state_38532__$1 = state_38532;
var statearr_38540_38566 = state_38532__$1;
(statearr_38540_38566[(2)] = null);

(statearr_38540_38566[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (3))){
var inst_38529 = (state_38532[(2)]);
var inst_38530 = cljs.core.async.close_BANG_(out);
var state_38532__$1 = (function (){var statearr_38541 = state_38532;
(statearr_38541[(9)] = inst_38529);

return statearr_38541;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_38532__$1,inst_38530);
} else {
if((state_val_38533 === (2))){
var state_38532__$1 = state_38532;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38532__$1,(4),ch);
} else {
if((state_val_38533 === (11))){
var inst_38512 = (state_38532[(8)]);
var inst_38521 = (state_38532[(2)]);
var inst_38509 = inst_38512;
var state_38532__$1 = (function (){var statearr_38542 = state_38532;
(statearr_38542[(7)] = inst_38509);

(statearr_38542[(10)] = inst_38521);

return statearr_38542;
})();
var statearr_38543_38567 = state_38532__$1;
(statearr_38543_38567[(2)] = null);

(statearr_38543_38567[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (9))){
var inst_38512 = (state_38532[(8)]);
var state_38532__$1 = state_38532;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38532__$1,(11),out,inst_38512);
} else {
if((state_val_38533 === (5))){
var inst_38512 = (state_38532[(8)]);
var inst_38509 = (state_38532[(7)]);
var inst_38516 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_38512,inst_38509);
var state_38532__$1 = state_38532;
if(inst_38516){
var statearr_38545_38568 = state_38532__$1;
(statearr_38545_38568[(1)] = (8));

} else {
var statearr_38546_38569 = state_38532__$1;
(statearr_38546_38569[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (10))){
var inst_38524 = (state_38532[(2)]);
var state_38532__$1 = state_38532;
var statearr_38547_38570 = state_38532__$1;
(statearr_38547_38570[(2)] = inst_38524);

(statearr_38547_38570[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38533 === (8))){
var inst_38509 = (state_38532[(7)]);
var tmp38544 = inst_38509;
var inst_38509__$1 = tmp38544;
var state_38532__$1 = (function (){var statearr_38548 = state_38532;
(statearr_38548[(7)] = inst_38509__$1);

return statearr_38548;
})();
var statearr_38549_38571 = state_38532__$1;
(statearr_38549_38571[(2)] = null);

(statearr_38549_38571[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38561,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38561,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38553 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_38553[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38553[(1)] = (1));

return statearr_38553;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38532){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38532);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38554){if((e38554 instanceof Object)){
var ex__35851__auto__ = e38554;
var statearr_38555_38572 = state_38532;
(statearr_38555_38572[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38532);

return cljs.core.cst$kw$recur;
} else {
throw e38554;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38573 = state_38532;
state_38532 = G__38573;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38532){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38532);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38561,out))
})();
var state__35963__auto__ = (function (){var statearr_38556 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38556[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38561);

return statearr_38556;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38561,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args38574 = [];
var len__5740__auto___38644 = arguments.length;
var i__5741__auto___38645 = (0);
while(true){
if((i__5741__auto___38645 < len__5740__auto___38644)){
args38574.push((arguments[i__5741__auto___38645]));

var G__38646 = (i__5741__auto___38645 + (1));
i__5741__auto___38645 = G__38646;
continue;
} else {
}
break;
}

var G__38576 = args38574.length;
switch (G__38576) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38574.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38648 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38648,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38648,out){
return (function (state_38614){
var state_val_38615 = (state_38614[(1)]);
if((state_val_38615 === (7))){
var inst_38610 = (state_38614[(2)]);
var state_38614__$1 = state_38614;
var statearr_38616_38649 = state_38614__$1;
(statearr_38616_38649[(2)] = inst_38610);

(statearr_38616_38649[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (1))){
var inst_38577 = (new Array(n));
var inst_38578 = inst_38577;
var inst_38579 = (0);
var state_38614__$1 = (function (){var statearr_38617 = state_38614;
(statearr_38617[(7)] = inst_38579);

(statearr_38617[(8)] = inst_38578);

return statearr_38617;
})();
var statearr_38618_38650 = state_38614__$1;
(statearr_38618_38650[(2)] = null);

(statearr_38618_38650[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (4))){
var inst_38582 = (state_38614[(9)]);
var inst_38582__$1 = (state_38614[(2)]);
var inst_38583 = (inst_38582__$1 == null);
var inst_38584 = cljs.core.not(inst_38583);
var state_38614__$1 = (function (){var statearr_38619 = state_38614;
(statearr_38619[(9)] = inst_38582__$1);

return statearr_38619;
})();
if(inst_38584){
var statearr_38620_38651 = state_38614__$1;
(statearr_38620_38651[(1)] = (5));

} else {
var statearr_38621_38652 = state_38614__$1;
(statearr_38621_38652[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (15))){
var inst_38604 = (state_38614[(2)]);
var state_38614__$1 = state_38614;
var statearr_38622_38653 = state_38614__$1;
(statearr_38622_38653[(2)] = inst_38604);

(statearr_38622_38653[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (13))){
var state_38614__$1 = state_38614;
var statearr_38623_38654 = state_38614__$1;
(statearr_38623_38654[(2)] = null);

(statearr_38623_38654[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (6))){
var inst_38579 = (state_38614[(7)]);
var inst_38600 = (inst_38579 > (0));
var state_38614__$1 = state_38614;
if(cljs.core.truth_(inst_38600)){
var statearr_38624_38655 = state_38614__$1;
(statearr_38624_38655[(1)] = (12));

} else {
var statearr_38625_38656 = state_38614__$1;
(statearr_38625_38656[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (3))){
var inst_38612 = (state_38614[(2)]);
var state_38614__$1 = state_38614;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38614__$1,inst_38612);
} else {
if((state_val_38615 === (12))){
var inst_38578 = (state_38614[(8)]);
var inst_38602 = cljs.core.vec(inst_38578);
var state_38614__$1 = state_38614;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38614__$1,(15),out,inst_38602);
} else {
if((state_val_38615 === (2))){
var state_38614__$1 = state_38614;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38614__$1,(4),ch);
} else {
if((state_val_38615 === (11))){
var inst_38594 = (state_38614[(2)]);
var inst_38595 = (new Array(n));
var inst_38578 = inst_38595;
var inst_38579 = (0);
var state_38614__$1 = (function (){var statearr_38626 = state_38614;
(statearr_38626[(10)] = inst_38594);

(statearr_38626[(7)] = inst_38579);

(statearr_38626[(8)] = inst_38578);

return statearr_38626;
})();
var statearr_38627_38657 = state_38614__$1;
(statearr_38627_38657[(2)] = null);

(statearr_38627_38657[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (9))){
var inst_38578 = (state_38614[(8)]);
var inst_38592 = cljs.core.vec(inst_38578);
var state_38614__$1 = state_38614;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38614__$1,(11),out,inst_38592);
} else {
if((state_val_38615 === (5))){
var inst_38587 = (state_38614[(11)]);
var inst_38582 = (state_38614[(9)]);
var inst_38579 = (state_38614[(7)]);
var inst_38578 = (state_38614[(8)]);
var inst_38586 = (inst_38578[inst_38579] = inst_38582);
var inst_38587__$1 = (inst_38579 + (1));
var inst_38588 = (inst_38587__$1 < n);
var state_38614__$1 = (function (){var statearr_38628 = state_38614;
(statearr_38628[(11)] = inst_38587__$1);

(statearr_38628[(12)] = inst_38586);

return statearr_38628;
})();
if(cljs.core.truth_(inst_38588)){
var statearr_38629_38658 = state_38614__$1;
(statearr_38629_38658[(1)] = (8));

} else {
var statearr_38630_38659 = state_38614__$1;
(statearr_38630_38659[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (14))){
var inst_38607 = (state_38614[(2)]);
var inst_38608 = cljs.core.async.close_BANG_(out);
var state_38614__$1 = (function (){var statearr_38632 = state_38614;
(statearr_38632[(13)] = inst_38607);

return statearr_38632;
})();
var statearr_38633_38660 = state_38614__$1;
(statearr_38633_38660[(2)] = inst_38608);

(statearr_38633_38660[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (10))){
var inst_38598 = (state_38614[(2)]);
var state_38614__$1 = state_38614;
var statearr_38634_38661 = state_38614__$1;
(statearr_38634_38661[(2)] = inst_38598);

(statearr_38634_38661[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38615 === (8))){
var inst_38587 = (state_38614[(11)]);
var inst_38578 = (state_38614[(8)]);
var tmp38631 = inst_38578;
var inst_38578__$1 = tmp38631;
var inst_38579 = inst_38587;
var state_38614__$1 = (function (){var statearr_38635 = state_38614;
(statearr_38635[(7)] = inst_38579);

(statearr_38635[(8)] = inst_38578__$1);

return statearr_38635;
})();
var statearr_38636_38662 = state_38614__$1;
(statearr_38636_38662[(2)] = null);

(statearr_38636_38662[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38648,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38648,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38640 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38640[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38640[(1)] = (1));

return statearr_38640;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38614){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38614);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38641){if((e38641 instanceof Object)){
var ex__35851__auto__ = e38641;
var statearr_38642_38663 = state_38614;
(statearr_38642_38663[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38614);

return cljs.core.cst$kw$recur;
} else {
throw e38641;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38664 = state_38614;
state_38614 = G__38664;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38614){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38614);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38648,out))
})();
var state__35963__auto__ = (function (){var statearr_38643 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38643[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38648);

return statearr_38643;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38648,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args38665 = [];
var len__5740__auto___38739 = arguments.length;
var i__5741__auto___38740 = (0);
while(true){
if((i__5741__auto___38740 < len__5740__auto___38739)){
args38665.push((arguments[i__5741__auto___38740]));

var G__38741 = (i__5741__auto___38740 + (1));
i__5741__auto___38740 = G__38741;
continue;
} else {
}
break;
}

var G__38667 = args38665.length;
switch (G__38667) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38665.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__35961__auto___38743 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__35961__auto___38743,out){
return (function (){
var f__35962__auto__ = (function (){var switch__35847__auto__ = ((function (c__35961__auto___38743,out){
return (function (state_38709){
var state_val_38710 = (state_38709[(1)]);
if((state_val_38710 === (7))){
var inst_38705 = (state_38709[(2)]);
var state_38709__$1 = state_38709;
var statearr_38711_38744 = state_38709__$1;
(statearr_38711_38744[(2)] = inst_38705);

(statearr_38711_38744[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (1))){
var inst_38668 = [];
var inst_38669 = inst_38668;
var inst_38670 = cljs.core.cst$kw$cljs$core$async_SLASH_nothing;
var state_38709__$1 = (function (){var statearr_38712 = state_38709;
(statearr_38712[(7)] = inst_38670);

(statearr_38712[(8)] = inst_38669);

return statearr_38712;
})();
var statearr_38713_38745 = state_38709__$1;
(statearr_38713_38745[(2)] = null);

(statearr_38713_38745[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (4))){
var inst_38673 = (state_38709[(9)]);
var inst_38673__$1 = (state_38709[(2)]);
var inst_38674 = (inst_38673__$1 == null);
var inst_38675 = cljs.core.not(inst_38674);
var state_38709__$1 = (function (){var statearr_38714 = state_38709;
(statearr_38714[(9)] = inst_38673__$1);

return statearr_38714;
})();
if(inst_38675){
var statearr_38715_38746 = state_38709__$1;
(statearr_38715_38746[(1)] = (5));

} else {
var statearr_38716_38747 = state_38709__$1;
(statearr_38716_38747[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (15))){
var inst_38699 = (state_38709[(2)]);
var state_38709__$1 = state_38709;
var statearr_38717_38748 = state_38709__$1;
(statearr_38717_38748[(2)] = inst_38699);

(statearr_38717_38748[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (13))){
var state_38709__$1 = state_38709;
var statearr_38718_38749 = state_38709__$1;
(statearr_38718_38749[(2)] = null);

(statearr_38718_38749[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (6))){
var inst_38669 = (state_38709[(8)]);
var inst_38694 = inst_38669.length;
var inst_38695 = (inst_38694 > (0));
var state_38709__$1 = state_38709;
if(cljs.core.truth_(inst_38695)){
var statearr_38719_38750 = state_38709__$1;
(statearr_38719_38750[(1)] = (12));

} else {
var statearr_38720_38751 = state_38709__$1;
(statearr_38720_38751[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (3))){
var inst_38707 = (state_38709[(2)]);
var state_38709__$1 = state_38709;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38709__$1,inst_38707);
} else {
if((state_val_38710 === (12))){
var inst_38669 = (state_38709[(8)]);
var inst_38697 = cljs.core.vec(inst_38669);
var state_38709__$1 = state_38709;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38709__$1,(15),out,inst_38697);
} else {
if((state_val_38710 === (2))){
var state_38709__$1 = state_38709;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38709__$1,(4),ch);
} else {
if((state_val_38710 === (11))){
var inst_38673 = (state_38709[(9)]);
var inst_38677 = (state_38709[(10)]);
var inst_38687 = (state_38709[(2)]);
var inst_38688 = [];
var inst_38689 = inst_38688.push(inst_38673);
var inst_38669 = inst_38688;
var inst_38670 = inst_38677;
var state_38709__$1 = (function (){var statearr_38721 = state_38709;
(statearr_38721[(7)] = inst_38670);

(statearr_38721[(8)] = inst_38669);

(statearr_38721[(11)] = inst_38689);

(statearr_38721[(12)] = inst_38687);

return statearr_38721;
})();
var statearr_38722_38752 = state_38709__$1;
(statearr_38722_38752[(2)] = null);

(statearr_38722_38752[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (9))){
var inst_38669 = (state_38709[(8)]);
var inst_38685 = cljs.core.vec(inst_38669);
var state_38709__$1 = state_38709;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38709__$1,(11),out,inst_38685);
} else {
if((state_val_38710 === (5))){
var inst_38673 = (state_38709[(9)]);
var inst_38670 = (state_38709[(7)]);
var inst_38677 = (state_38709[(10)]);
var inst_38677__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_38673) : f.call(null,inst_38673));
var inst_38678 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_38677__$1,inst_38670);
var inst_38679 = cljs.core.keyword_identical_QMARK_(inst_38670,cljs.core.cst$kw$cljs$core$async_SLASH_nothing);
var inst_38680 = (inst_38678) || (inst_38679);
var state_38709__$1 = (function (){var statearr_38723 = state_38709;
(statearr_38723[(10)] = inst_38677__$1);

return statearr_38723;
})();
if(cljs.core.truth_(inst_38680)){
var statearr_38724_38753 = state_38709__$1;
(statearr_38724_38753[(1)] = (8));

} else {
var statearr_38725_38754 = state_38709__$1;
(statearr_38725_38754[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (14))){
var inst_38702 = (state_38709[(2)]);
var inst_38703 = cljs.core.async.close_BANG_(out);
var state_38709__$1 = (function (){var statearr_38727 = state_38709;
(statearr_38727[(13)] = inst_38702);

return statearr_38727;
})();
var statearr_38728_38755 = state_38709__$1;
(statearr_38728_38755[(2)] = inst_38703);

(statearr_38728_38755[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (10))){
var inst_38692 = (state_38709[(2)]);
var state_38709__$1 = state_38709;
var statearr_38729_38756 = state_38709__$1;
(statearr_38729_38756[(2)] = inst_38692);

(statearr_38729_38756[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38710 === (8))){
var inst_38673 = (state_38709[(9)]);
var inst_38669 = (state_38709[(8)]);
var inst_38677 = (state_38709[(10)]);
var inst_38682 = inst_38669.push(inst_38673);
var tmp38726 = inst_38669;
var inst_38669__$1 = tmp38726;
var inst_38670 = inst_38677;
var state_38709__$1 = (function (){var statearr_38730 = state_38709;
(statearr_38730[(7)] = inst_38670);

(statearr_38730[(8)] = inst_38669__$1);

(statearr_38730[(14)] = inst_38682);

return statearr_38730;
})();
var statearr_38731_38757 = state_38709__$1;
(statearr_38731_38757[(2)] = null);

(statearr_38731_38757[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__35961__auto___38743,out))
;
return ((function (switch__35847__auto__,c__35961__auto___38743,out){
return (function() {
var cljs$core$async$state_machine__35848__auto__ = null;
var cljs$core$async$state_machine__35848__auto____0 = (function (){
var statearr_38735 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38735[(0)] = cljs$core$async$state_machine__35848__auto__);

(statearr_38735[(1)] = (1));

return statearr_38735;
});
var cljs$core$async$state_machine__35848__auto____1 = (function (state_38709){
while(true){
var ret_value__35849__auto__ = (function (){try{while(true){
var result__35850__auto__ = switch__35847__auto__(state_38709);
if(cljs.core.keyword_identical_QMARK_(result__35850__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__35850__auto__;
}
break;
}
}catch (e38736){if((e38736 instanceof Object)){
var ex__35851__auto__ = e38736;
var statearr_38737_38758 = state_38709;
(statearr_38737_38758[(5)] = ex__35851__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38709);

return cljs.core.cst$kw$recur;
} else {
throw e38736;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__35849__auto__,cljs.core.cst$kw$recur)){
var G__38759 = state_38709;
state_38709 = G__38759;
continue;
} else {
return ret_value__35849__auto__;
}
break;
}
});
cljs$core$async$state_machine__35848__auto__ = function(state_38709){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__35848__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__35848__auto____1.call(this,state_38709);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__35848__auto____0;
cljs$core$async$state_machine__35848__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__35848__auto____1;
return cljs$core$async$state_machine__35848__auto__;
})()
;})(switch__35847__auto__,c__35961__auto___38743,out))
})();
var state__35963__auto__ = (function (){var statearr_38738 = (f__35962__auto__.cljs$core$IFn$_invoke$arity$0 ? f__35962__auto__.cljs$core$IFn$_invoke$arity$0() : f__35962__auto__.call(null));
(statearr_38738[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__35961__auto___38743);

return statearr_38738;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__35963__auto__);
});})(c__35961__auto___38743,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;
